# -- config.tcl
# sauve/restore une config avec attributs de fenetres/fichiers
# (save workspace / restaure workspace)
# (c) Pascal Bouvier 22/12/1997



# window:saveconfig cree un fichier contenant des lignes de la forme:
# window:config fichier couleurFond fonte geometry
# EX: window:config {C:/users/pascal/cea/tcl/acteur.tcl} white {courier 10 {}} 660x463+321+115 (iconic/normal)
proc window:saveconfig {{fileconf toto.conf}} {
	global edit_files
	set stream [open $fileconf w]
	
	set L "window:open" 
	lappend L [array names edit_files]
	puts $stream $L
	foreach fname [array names edit_files] {
		set W $edit_files($fname)
		set topl [winfo parent $W]
		puts $stream "window:config {$fname} [$W.t cget -backg] \
			\{[$W.t cget -font]\} \
			[wm geo $topl] [wm state $topl]"
		}
	close $stream
}

#
#
#
proc window:open {listfiles} {
	foreach fn $listfiles {
		edit:open_window $fn
		}
	update
}

#
#
#
proc window:config {fn bgcoul font geo state} {
	global edit_files
	if [catch {set edit_files($fn)} W] return
	set topl [winfo parent $W]
	wm geo $topl $geo
	if {[string compare $state iconic] == 0} {
		wm iconify $topl
		}
	$W.t config -font $font -backg $bgcoul
}

if 0 {
parray edit_eds donne:

edit_eds(.ed10.frEdit) = C:/users/pascal/cea/tcl/acteur.tcl
edit_eds(.ed11.frEdit) = C:/users/pascal/cea/tcl/casting.tcl
edit_eds(.ed15.frEdit) = C:/users/pascal/ENVI/TCL/find.tcl
edit_eds(.ed17.frEdit) = C:/users/pascal/ENVI/TCL/edit.tcl
edit_eds(.ed2.frEdit)  = C:/users/pascal/cea/tcl/coulisses.tcl
edit_eds(.ed3.frEdit)  = C:/users/pascal/cea/tcl/scene.tcl
edit_eds(.ed4.frEdit)  = C:/users/pascal/cea/tcl/utils.tcl
edit_eds(.ed8.frEdit)  = C:/users/pascal/cea/tcl/actions.tcl
edit_eds(.ed9.frEdit)  = C:/users/pascal/cea/tcl/superviseur.tcl

parray edit_files donne:
edit_files(C:/users/pascal/CEA/TCL/Untitled-21)     = .ed21.frEdit
edit_files(C:/users/pascal/ENVI/TCL/edit.tcl)       = .ed17.frEdit
edit_files(C:/users/pascal/ENVI/TCL/find.tcl)       = .ed15.frEdit
edit_files(C:/users/pascal/cea/tcl/acteur.tcl)      = .ed10.frEdit
edit_files(C:/users/pascal/cea/tcl/actions.tcl)     = .ed8.frEdit
edit_files(C:/users/pascal/cea/tcl/casting.tcl)     = .ed11.frEdit
edit_files(C:/users/pascal/cea/tcl/coulisses.tcl)   = .ed2.frEdit
edit_files(C:/users/pascal/cea/tcl/scene.tcl)       = .ed3.frEdit
edit_files(C:/users/pascal/cea/tcl/superviseur.tcl) = .ed9.frEdit
edit_files(C:/users/pascal/cea/tcl/utils.tcl)       = .ed4.frEdit

foreach f [array names edit_eds] {
   set topl [winfo parent $f]
   puts " wm geo $topl [wm geo $topl]"
}

donne:
 wm geo .ed15 660x463+124+141
 wm geo .ed8 581x546+155+60
 wm geo .ed17 660x463+91+92
 wm geo .ed10 660x463+321+115
 wm geo .ed3 622x546+127+137
 wm geo .ed9 660x463+132+132
 wm geo .ed2 580x511+196+169
 wm geo .ed11 660x533+137+107
 wm geo .ed21 660x463+255+123
 wm geo .ed4 579x505+336+225

foreach f [array names edit_eds] {
   puts "$f.t config -font \{[$f.t cget -font]\}"
}
donne:
.ed15.frEdit.t config -font {courier 10 {}}
.ed8.frEdit.t config -font {courier -15 {}}
.ed17.frEdit.t config -font {courier 10 {}}
.ed10.frEdit.t config -font {courier 10 {}}
.ed3.frEdit.t config -font {courier 9 {}}
.ed9.frEdit.t config -font {courier 10 {}}
.ed2.frEdit.t config -font {courier 9 {}}
.ed11.frEdit.t config -font {courier -15 {}}
.ed21.frEdit.t config -font {courier 10 {}}
.ed4.frEdit.t config -font {"courier new" -15 {}}

foreach f [array names edit_eds] {
   puts "$f.t config -backg \{[$f.t cget -backg]\}"
}
donne:

.ed15.frEdit.t config -backg {white}
.ed8.frEdit.t config -backg {orange1}
.ed17.frEdit.t config -backg {white}
.ed10.frEdit.t config -backg {white}
.ed3.frEdit.t config -backg {lightgreen}
.ed9.frEdit.t config -backg {white}
.ed2.frEdit.t config -backg {ivory}
.ed11.frEdit.t config -backg {pink}
.ed21.frEdit.t config -backg {white}
.ed4.frEdit.t config -backg {#ffffaa}
}

# -- EOF
