# -- constcl.tcl
# Petite console pour TCL
#
# Auteur:			 Pascal Bouvier
# Creation:			 ../../95
# Modifications:	 PBO 06/11/96  Enlevement de catch
#
# (c) PrologIA 1995
# -----------------------------------------------------------------------------


# -----------------------------------------------------------------------------
# Initialisation de la console
# -----------------------------------------------------------------------------
proc constcl:init {} {
	toplevel .constcl
	wm minsize .constcl 1 1
	wm title .constcl [lang: T-tconsole]
#	wm geo .constcl +38+185
	wm geo .constcl +80-28

	frame .constcl.f
	button .constcl.f.br -text "Evaluate Region" \
			-command "constcl:evalregion .constcl.t"
	button .constcl.f.bs -text "Eval.Sel." \
			-command "constcl:evalsel .constcl.t"
	pack .constcl.f.br -side left -fill x -expand y
	pack .constcl.f.bs -side left
	pack .constcl.f -side bottom -fill x

	text .constcl.t -bd 1 -yscrollcommand {.constcl.s set} -wid 50 -hei 10
	scrollbar .constcl.s -orient vertical \
			-command {.constcl.t yview} -relief sunken
	pack .constcl.t -side left -expand yes -fill both
	pack .constcl.s -side left -fill y

	bind .constcl.t <KP_Enter> "constcl:evalregion .constcl.t"
	bind .constcl.t <Shift-Return> "constcl:evalregion .constcl.t"
	bind .constcl.t <Control-Return> "constcl:evalregion .constcl.t"
}

# -----------------------------------------------------------------------------
# Evalue une region selectionnee, ou la ligne contenant le caret
# -----------------------------------------------------------------------------
proc constcl:evalregion {W} {
	if {[$W tag nextrange sel 1.0] == ""} {
		# pas de selection
		set deb [$W index {insert linestart}]
		set fin [$W index {insert lineend}]
		} \
	else {
		# est-ce que le caret est dans la selection ou pas ?
		if {[$W compare insert < sel.first] || [$W compare insert > sel.last]} {
			# en dehors de la selection
			set deb [$W index {insert linestart}]
			set fin [$W index {insert lineend}]
			} \
		else {
			set deb [$W index sel.first]
			set fin [$W index sel.last]
			}
		}
	set finl [$W index "$fin lineend"]
	$W mark set insert $finl
	$W insert insert \n

	$W insert insert [eval uplevel #0 \
			\{[string trim [$W get $deb $fin]]\}]
}

# -----------------------------------------------------------------------------
# Evalue le contenu de la selection courante (dans quelque fenetre qu'elle soit)
# -----------------------------------------------------------------------------
proc constcl:evalsel {W} {
	$W insert insert [eval uplevel #0  \{[string trim [selection get]]\}]
}


# -- EOF constcl.tcl --------------------------------------------------------
