# -- dbgtop4.tcl
# Quoi: Connection avec Prolog IV (debugger)
# 
# Auteur:			Pascal Bouvier
# Creation:			07/05/95 d'apres com.tcl
# Modifications:	
# 
# (c) PrologIA 1995
#
# -----------------------------------------------------------------------------


# -----------------------------------------------------------------------------
# Lit la table de symdbg du fichier C (DBGOBJ/menu.g.c)
# Pourquoi : Pour montrer les endroits debuggables exacts
# pour y faire les break-points.
# Elle n'est lue que si necessaire (date changee, ...)
# -----------------------------------------------------------------------------
proc dbg_read_cdbg_table F {
#	global $F
#	global dbgdate
#	if {[dbg:loaded_date $F] == [file mtime $F]} {return}
#
#	if { ! [file exists $F] } {
#		dbg:puts_error "dbg error: can't read c-symbol file \"$F\""
#		return
#		}
#	set $F {}
#	#
#	# Lit des lignes dans le fichier .c au format:
#	#	M_debug_entry(27, proc_8_2, "meat_2_2", -1)
#	#
#	dbg:puts_error "Loading c-symbol file \"$F\" ..."
#	for_file line $F {
#		if {4 == [scan $line {M_debug_entry(%d, %[^,], "%[^"]", %d)} a b c d]} #{
#			lappend $F [list $a $b $c $d]
#			}
#		}
#	set dbgdate($F) [file mtime $F]
#}

#
# Retourne {master incl} d'un fichier inclu, ou "" s'il n'est pas inclu
#
proc dbg_find_master {name} {
	global dbginclude
	foreach i [array names dbginclude] {
		if {"$name" == "[lindex $dbginclude($i) 0]"} {
			set virg [string last , $i]
			set ret [list [string range $i 0 [expr $virg-1]] \
						[string range $i [expr $virg+1] end]]
			return $ret
			}
		}
	return ""
}

# -----------------------------------------------------------------------------
# retourne la date de chargement d'un fichier (table) ou
# 0 si n'a jamais ete charge.
# -----------------------------------------------------------------------------
proc dbg:loaded_date {f} {
	global dbgdate
	if {[catch "set dbgdate($f)" mtime]} {
		set mtime 0
		}
	return $mtime
}

# -----------------------------------------------------------------------------
# La table etendue contenant des regions de texte (DBGOBJ/menu.sym)
# Elle n'est lue que si necessaire (date changee, ...)
# -----------------------------------------------------------------------------
proc dbg_read_xdbg_table {f} {
	global dbgdate
	if {[dbg:loaded_date $f] < [file mtime $f]} {
		if {[is-existing&readable&regular $f]} {
			dbg:puts_error "Loading symbol file \"$f\" ..."
			uplevel #0 source $f
			set dbgdate($f) [file mtime $f]
			} \
		else {
			dbg:puts_error "dbg error: can't read x-symbol file \"$f\""
			return
			}
		}
}

# -----------------------------------------------------------------------------
# Montre les lignes ou ca peut s'arreter
# d'apres le fichier C genere (pas d'apres les tables du fichier .sym)
# -----------------------------------------------------------------------------
proc dbg_showstoppable {T fname incl} {
	foreach i $T {
		set l [lindex $i 3]
		if { $l > 999999 } {
			global dbg
			set nincl [expr $l / 1000000]
			if { $nincl == $incl } {
				set off [expr $l % 1000000]
				set region [lindex $dbg($fname,$nincl) $off]
				lassign $region l1 l2
				.dbgp4.frEdit.t tag add stoppable $l1 $l2
				.dbgp4.frEdit.t tag add $l $l1 $l2
				}
			}
		}
}

# -----------------------------------------------------------------------------
# Ecrit la chaine str dans le panel-output du debugger (style-out)
# Par defaut, met newline apres la chaine.
# -----------------------------------------------------------------------------
proc dbg:puts {str {nl \n}} {
	global conn:current_wout
	tty:insere_style out ${conn:current_wout} $str $nl
}

# -----------------------------------------------------------------------------
# Ecrit la chaine str dans le panel-output du debugger en style-error
# Par defaut, met newline apres la chaine.
# -----------------------------------------------------------------------------
proc dbg:puts_error {str {nl \n}} {
	global conn:current_wout
	tty:insere_style error ${conn:current_wout} $str $nl
}

# -----------------------------------------------------------------------------
# Ecrit la chaine str dans le panel-output du debugger en style-user
# Par defaut, met newline apres la chaine.
# -----------------------------------------------------------------------------
proc dbg:puts_user {str {nl \n}} {
	global conn:current_wout
	tty:insere_style user ${conn:current_wout} $str $nl
}

# -----------------------------------------------------------------------------
# La boucle est lancee du bouton "machinerie" du debugger
# C'est ici qu'on ecoute ce qui vient du pipe
# -----------------------------------------------------------------------------
#proc dbg_g {} {
#	global dbgvar f1
#	set r 0
#	while { $dbgvar(istalking) } {
#		update
#		if [set r [catch {cons:waitio .dbgp4.frtty.t $f1}]] {
#			set dbgvar(istalking) 0
#			}
#		}
#	if $r {
##		dbg:puts_error "\"$dbgvar(nameexec)\" has exited. ($r)"
#		dbg:setstate "Off"
#		set dbgvar(isrunning) 0
#		}
##	puts "L'exe \"$dbgvar(execpipe)\" est arrete. ($r)"
#}

if 0 {
#
# UNUSED Menus et tout ca qui va avec
#

#menubutton .fr.mf -menu .fr.mf.mfile -textvariable mfile
#set mfile "Fichier"
#.fr.mf confi -underline 0
#menu .fr.mf.mfile 
#.fr.mf.mfile add command -label "Nouveau"
#.fr.mf.mfile add command -label "Ouvrir..."
#.fr.mf.mfile add sepa
#.fr.mf.mfile add command -label "Quitter..." -underline 1 -command {puts ok}
#
#menubutton .fr.me -textvariable medit -menu .fr.me.medit
#set medit "Edition"
#menu .fr.me.medit 
#.fr.me.medit add command -label Cut
#.fr.me.medit add command -label Copy
#.fr.me.medit add command -label Paste
#.fr.me.medit add command -label Clear
#.fr.me.medit add sepa
#.fr.me.medit add command -label "Delete All" -command {.f del 1.0 end}
#
#pack .fr.mf .fr.me -side left -padx 2m -pady 2m
#
#tk_menuBar .fr .fr.mf .fr.me
}

#-- EOF dbgtop4.tcl --------------------
