# -- dialog.tcl
# quelques outils pour les dialogues
#
# Auteur:		Pascal Bouvier
# Creation:		27/08/96
# Modifications:	
#
# (c) PrologIA 1995
# -----------------------------------------------------------------------------


# ==== G L O B A L E S =======================================

# pour le retour du dialogue dial:oui_non
global dial:oui_non_answer


# ==== P R O C S =======================================

# -----------------------------------------------------------------------------
# Centrer une fenetre a l'ecran
# -----------------------------------------------------------------------------
proc dial:centrer {W} {
	set x [expr ([winfo screenwidth $W] - [winfo reqwidth $W])/2]
	set y [expr ([winfo screenheight $W] - [winfo reqheight $W])/2]

	wm geo $W +$x+$y
}

# -----------------------------------------------------------------------------
# Un dialogue en oui/non avec message et boutons parametrables
# le retour est en 0/1
# -----------------------------------------------------------------------------
proc dial:oui_non {message {title Alert} {Oui Ok} {Non No}} {
	upvar #0 font_for_menus fnt
	global dial:oui_non_answer

	set W .alert
	toplevel $W
	wm title $W $title

	set fmess $W.fm
	frame $fmess
	label $fmess.lico -bitmap questhead
	message $fmess.mess -text $message -font $fnt -aspect 700
	pack $fmess.lico $fmess.mess -side left -padx 5m -pady 1m

	set fbut $W.fb
	frame $fbut
	pack $fmess $fbut -side top

	# le bouton No
	button $fbut.bno -text $Non -comm "set dial:oui_non_answer 0; destroy $W" -font $fnt

	# le frame du bouton ok, par defaut, dans son frame 'default'
	frame $fbut.fd -relief sunken -bd 1
	pack $fbut.fd $fbut.bno -side left -pady 3m -padx 5m 

	button $fbut.fd.bok -text $Oui -comm "set dial:oui_non_answer 1; destroy $W" -font $fnt
	pack $fbut.fd.bok -padx 1m -pady 1m; # -ipadx 2m -ipady 1m
	bind $fbut <Return> "$fbut.fd.bok invoke"
	set oldf [focus]
	focus $fbut

	wm withdraw $W
	update idletasks
	dial:centrer $W
	wm deiconify $W
	bip

	grab $W
	tkwait window $W
	focus $oldf
	return ${dial:oui_non_answer}
}

# -----------------------------------------------------------------------------
# Appelee si probleme 
# -----------------------------------------------------------------------------
proc dial:alert {message {title Alert}} {
	upvar #0 font_for_menus fnt

	set W .alert
	toplevel $W
	wm title $W $title

	set fmess $W.fm
	frame $fmess
	label $fmess.lico -bitmap questhead
	message $fmess.mess -text $message -font $fnt -aspect 700
	pack $fmess.lico $fmess.mess -side left -padx 5m -pady 1m

	set fbut $W.fb
	frame $fbut
	pack $fmess $fbut -side top

	# le frame du bouton ok, par defaut, dans son frame 'default'
	frame $fbut.fd -relief sunken -bd 1
	pack $fbut.fd -side left -pady 3m -padx 5m 

	button $fbut.fd.bok -text "Ok" -comm "destroy $W" -font $fnt
	pack $fbut.fd.bok -padx 1m -pady 1m -ipadx 2m -ipady 1m
	bind $fbut <Return> "$fbut.fd.bok invoke"
	set oldf [focus]
	focus $fbut

	wm withdraw $W
	update idletasks
	dial:centrer $W
	wm deiconify $W
	bip

	grab $W
	tkwait window $W
	focus $oldf
}

#-- EOF dialog.tcl --------------------------------------------------------------
