# -- edcom.tcl
# Commandes d'edition de l'editeur
#
# Auteur:		Pascal Bouvier
# Creation:		../01/95
# Modifications:	
#				PB  23/05/95 2eme chantier
#				PBO 29/09/96 refonte tk4.1
#				PBO 22/07/98 ajout balance
#
# (c) PrologIA 1995
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# L'affichage de l'endroit ou on est lig.col
# TMP
# manque l'affichage [pos1-pos2]
# tk4.1
# -----------------------------------------------------------------------------
proc eda:displayinsert {W} {
	$W see insert
	[winfo parent $W].fs.pos config -text [$W index insert]
}

#==============================================================================
#		I N S E R T I O N   de caracteres
#==============================================================================

# -----------------------------------------------------------------------------
# Insere un caractere donne
# tk4.1
# -----------------------------------------------------------------------------
proc edc:insertkey {W A} {
	if [ed:isreadonly $W] return

	if {($A == "") || ([$W cget -state] == "disabled")} {
		return
		}
	catch {
		if {[$W compare sel.first <= insert]
				&& [$W compare sel.last >= insert]} {
			eda:savesel $W
			$W delete sel.first sel.last
			}
		}
	$W insert insert $A

	ed:setdirty $W
	set ed [winfo parent $W]
	upvar #0 $ed tab
	if {"$A" == "\n"  &&  $tab(autoindent) } {
		$W insert insert [eda:indent $W]
		}
	if $tab(dynacolor) {
		ed:dyncol:$tab(lang):colorie $W
		}
	eda:displayinsert $W
}

# -----------------------------------------------------------------------------
# Met a jour un editeur
# (met "modifie", recolorie, affiche le caret et la position)
# NEW ! tk4.1
# -----------------------------------------------------------------------------
proc eda:update {W} {
	ed:setdirty $W
	set ed [winfo parent $W]
	upvar #0 $ed tab
	if $tab(dynacolor) {
		ed:dyncol:$tab(lang):colorie $W
		}
	eda:displayinsert $W
}

# -----------------------------------------------------------------------------
# Retourne le texte servant a indenter, base sur la ligne precedente
# -----------------------------------------------------------------------------
proc eda:indent {W} {
	set l [expr int([$W index insert])-1]
	if {$l >= 1 } {
		set p $l.0
		while {1} {
			set c [$W get $p]
			if { $c != " "  &&  $c != "\t" } break
			set p [$W index $p+1c]
			}
		return [$W get $l.0 $p]
		} \
	else {
		return ""
		}
}

# -----------------------------------------------------------------------------
# Efface le caractere precedent
# (selon le mode mac, devrait effacer la selection)
# -----------------------------------------------------------------------------
#3proc ed:backspace {W} {
#3	if [ed:isreadonly $W] return
#3
#3	tk_textBackspace $W
#3	ed:setdirty $W
#3	set ed [winfo parent $W]
#3	upvar #0 $ed tab
#3	if $tab(dynacolor) {
#3		ed:dyncol:$tab(lang):colorie $W
#3		}
#3	eda:displayinsert $W
#3}

# -----------------------------------------------------------------------------
# Le decalage a droite (imbrication)
# (devrait indenter selon une variable shiftwidth)
# pour l'instant, on se contente d'inserer un tab avant chaque ligne
# -----------------------------------------------------------------------------
proc edc:shift-right {W} {
	if [ed:isreadonly $W] return

	if {![catch "$W index sel.first"]} {
		# selection
		set p1 [$W index sel.first]
		set p2 [$W index sel.last]
		scan $p1 "%d.%d" p1 _
		scan $p2 "%d.%d" p2 a
		# car double-click sur la ligne 18 donne 19.0
		if {$a == 0} { incr p2 -1 }
		} \
	else {
		set p1 [$W index insert]
		scan $p1 "%d.%d" p1 _
		set p2 $p1
		}
		
	for {set i $p1} {$i <= $p2} {incr i} {
		$W insert $i.0 \t
		}
	$W tag add sel $p1.0 $p2.end
	ed:setdirty $W
	eda:displayinsert $W
}

# -----------------------------------------------------------------------------
# Le decalage a gauche (desimbrication)
# (devrait indenter selon une variable shiftwidth)
# pour l'instant, on se contente d'enlever un tab avant chaque ligne
# ou rien si c'est pas un tab
# -----------------------------------------------------------------------------
proc edc:shift-left {W} {
	if [ed:isreadonly $W] return

	if {![catch "$W index sel.first"]} {
		# selection
		set p1 [$W index sel.first]
		set p2 [$W index sel.last]
		scan $p1 "%d.%d" p1 _
		scan $p2 "%d.%d" p2 a
		# car double-click sur la ligne 18 donne 19.0
		if {$a == 0} { incr p2 -1 }
		} \
	else {
		set p1 [$W index insert]
		scan $p1 "%d.%d" p1 _
		set p2 $p1
		}
		
	for {set i $p1} {$i <= $p2} {incr i} {
		if { [$W get $i.0] == "\t" } {
			$W delete $i.0
			}
		}
	$W tag add sel $p1.0 $p2.end
	ed:setdirty $W
	eda:displayinsert $W
}


#==============================================================================
#			Divers pour la  S E L E C T I O N
#==============================================================================

#
# Informelle
#
proc eda:savesel {W} {
	global edit:last_deleted edit:last_ed
	set edit:last_deleted [$W get sel.first sel.last]
	set edit:last_ed $W
}

#
# Pour rendre le dernier delete (au cas ou)
#
proc eda:restore_deleted {{W ""}} {
	global edit:last_deleted edit:last_ed
	if {$W == ""} { set W ${edit:last_ed} }
	$W insert insert ${edit:last_deleted}
}

#
#
#
proc edc:select-all {W} {
	$W tag add sel 1.0 end
}

#===============================================================================
# Equilibrage de caracteres (pair-matching)
# {} () [] ""
#===============================================================================
proc edc:balance {t {act blinkall}} {
	$t tag config b1 -back blue -fore white
	$t tag config b2 -back white -fore blue
	
	set sens 0
	set nb 1
	set pfirst [$t index insert]
	set cfirst [$t get insert]
	switch -exact -- $cfirst {
	 "{"	{ set sens +1 ; set cfind \}  }
	 "}"	{ set sens -1 ; set cfind \{  }
	 "("	{ set sens +1 ; set cfind \)  }
	 ")"	{ set sens -1 ; set cfind \(  }
	 "["	{ set sens +1 ; set cfind \]  }
	 "]"	{ set sens -1 ; set cfind \[  }
	 "\""	{ set sens +1 ; set cfind \"  }
	 default return
	 }
	set pos [$t index "insert ${sens}c"]

	while 1 {
		set c [$t get $pos]
		if {$c == $cfind} {
			incr nb -1
			} \
		elseif {$c == $cfirst} {
			incr nb
			}
		if {$nb == 0} break
		set pos [$t index "$pos ${sens}c"]
		if [$t compare $pos >= end] {bell;break}
		if [$t compare $pos == 1.0] {bell;break}
		}

	switch -- $act {
	blink1 { # 2 clignotements de l'autre car.
		$t tag add b1 $pos
		update
		after 200
		$t tag remove b1 $pos
		update
		after 200
		$t tag add b1 $pos
		update
		after 200
		$t tag remove b1 $pos
		}
	blinkall { # 2 clignotements du tout
		if {$sens == "-1"} {
			set x $pos; set pos $pfirst; set pfirst $x
			}
		set pos [$t index "$pos +1c"]
		$t tag add b1 $pfirst $pos
		update
		after 200
		$t tag remove b1 $pfirst $pos
		update
		after 200
		$t tag add b1 $pfirst $pos
		update
		after 200
		$t tag remove b1 $pfirst $pos
		}
	select { # selection du texte
		if {$sens == "-1"} {
			set x $pos; set pos $pfirst; set pfirst $x
			}
		set pos [$t index "$pos +1c"]
		$t tag add sel $pfirst $pos
		}
	}
}


#==============================================================================
# Cut/Copy/Paste a la Macintosh/NeXT
#==============================================================================
#
# tk4.1
#
proc edc:cut {W} {
	if {[selection own -displayof $W] == "$W"} {
		if [ed:isreadonly $W] return
		clipboard clear -displayof $W
		catch {
			clipboard append -displayof $W [selection get -displayof $W]
			eda:savesel $W
			$W delete sel.first sel.last
			}
		eda:update $W
		}
}

#
# tk4.1
#
proc edc:clear {W} {
	if {[selection own -displayof $W] == "$W"} {
		if [ed:isreadonly $W] return
		catch {
			eda:savesel $W
			$W delete sel.first sel.last
			}
		eda:update $W
		}
}

#
# tk4.1
#
proc edc:copy {W} {
	tk_textCopy $W
}

#
# NEW ! 
# tk4.1
proc edc:copy-append {W} {
	if {[selection own -displayof $W] == "$W"} {
		catch {
			clipboard append -displayof $W [selection get -displayof $W]
			}
		}
}

#
# tk4.1
#
proc edc:paste {W} {
	if [ed:isreadonly $W] return

	set deb [$W index insert-3c]

    catch {
		$W insert insert [selection get -displayof $W  -selection CLIPBOARD]
		}

	ed:setdirty $W
	set ed [winfo parent $W]
	upvar #0 $ed tab
	if $tab(dynacolor) {
		set fin [$W index insert+1c]
		ed:dyncol:$tab(lang):colorie $W $deb $fin
		}
	eda:displayinsert $W
    }

#
# Paste from X11
# tk4.1
#
proc edc:paste-selection {W} {
	if [ed:isreadonly $W] return

	set deb [$W index insert-3c]
    catch {
		$W insert insert [selection get -displayof $W]
		}
	ed:setdirty $W
	set ed [winfo parent $W]
	upvar #0 $ed tab
	if $tab(dynacolor) {
		set fin [$W index insert+1c]
		ed:dyncol:$tab(lang):colorie $W $deb $fin
		}
	eda:displayinsert $W
    }


# -- EOF edcom.tcl -------------------------------------
