# -- emacs.tcl
# Bindings des touches (editeurs, menu, ...) pour Emacs
#
# Auteur:               Pascal Bouvier
# Creation:             25/09/96
# Modifications:
#
# (c) PrologIA 1996
# -----------------------------------------------------------------------------



@com {
On definit les classes d'evenements :
- ted_commun
- ted_motif
- ted_emacs
- ted_mac

- tty_commun
- tty_motif
- tty_emacs
- tty_mac

Les touches dans ce ficher :
C-h
C-y C-w M-w
M-Del M-BS
M-> M-<
M-f M-b
M-d
C-v
C-t
C-p C-n
C-o
C-k
C-d
C-f C-b
C-a C-e
x
INS
F18 F20 F16
C-\ C-/
C-S-SPACE  C-SPACE
BS DEL
RET
C-i TAB
}


#
# GENERAL
#

bind:addkey ted_common <Key-KP_Enter> none {# nothing}

bind:addkey ted_common <Key-Escape> none {# nothing}

bind:addkey ted_common <Control-Key> none {# nothing}

bind:addkey ted_common <Meta-Key> none {# nothing}

bind:addkey ted_common <Alt-Key> none {# nothing }



# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-h> delete-previous-char {
    if !$tk_strictMotif {
	if [%W compare insert != 1.0] {
	    %W delete insert-1c
		eda:update %W
	}
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-y> paste {edc:paste %W}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-w> cut {edc:cut %W}

# TEXT EMACS CHCLIP
bind:addkey ted_emacs <Meta-Key-w> copy {edc:copy %W}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Meta-Key-Delete> delete-previous-word {
    if !$tk_strictMotif {
	%W delete {insert -1c wordstart} insert
	eda:update %W
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Meta-Key-BackSpace> delete-previous-word {
    if !$tk_strictMotif {
	%W delete {insert -1c wordstart} insert
	eda:update %W
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Meta-Key-greater> goto-eof {
    if !$tk_strictMotif {
	tkTextSetCursor %W end-1c
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Meta-Key-less> goto-bof {
    if !$tk_strictMotif {
	tkTextSetCursor %W 1.0
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Meta-Key-f> goto-next-word {
    if !$tk_strictMotif {
	tkTextSetCursor %W {insert wordend}
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Meta-Key-d> delete-next-word {
    if !$tk_strictMotif {
	%W delete insert {insert wordend}
	eda:update %W
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Meta-Key-b> goto-previous-word {
    if !$tk_strictMotif {
	tkTextSetCursor %W {insert - 1c wordstart}
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-v> goto-next-page {
    if !$tk_strictMotif {
	tkTextScrollPages %W 1
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-t> twiddle-chars {
    if !$tk_strictMotif {
	tkTextTranspose %W
	eda:update %W
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-p> goto-previous-line {
    if !$tk_strictMotif {
	tkTextSetCursor %W [tkTextUpDownLine %W -1]
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-o> open-line {
    if !$tk_strictMotif {
	%W insert insert \n
	%W mark set insert insert-1c
	eda:update %W
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-n> goto-next-line {
    if !$tk_strictMotif {
	tkTextSetCursor %W [tkTextUpDownLine %W 1]
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-k> delete-to-eol {
    if !$tk_strictMotif {
	if [%W compare insert == {insert lineend}] {
	    %W delete insert
	} else {
	    %W delete insert {insert lineend}
	}
	eda:update %W
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-f> goto-next-char {
    if !$tk_strictMotif {
	tkTextSetCursor %W insert+1c
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-e> goto-eol {
    if !$tk_strictMotif {
	tkTextSetCursor %W {insert lineend}
    }
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-d> delete-next-char {
    if !$tk_strictMotif {
	%W delete insert
	eda:update %W
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-b> goto-previous-char {
    if !$tk_strictMotif {
	tkTextSetCursor %W insert-1c
    }
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-a> goto-bol {
    if !$tk_strictMotif {
	tkTextSetCursor %W {insert linestart}
    }
}

bind:addkey ted_emacs <Key-KP_Enter> none {# nothing}

bind:addkey ted_emacs <Key-Escape> none {# nothing}

bind:addkey ted_emacs <Control-Key> none {# nothing}

bind:addkey ted_emacs <Meta-Key> none {# nothing}

bind:addkey ted_emacs <Alt-Key> none {# nothing }

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key> insert-char {
    edc:insertkey %W %A
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-Insert> paste-selection {
    catch {edc:insertkey %W [selection get -displayof %W]}
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-F18> paste {edc:paste %W}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-F20> cut {edc:cut %W}

# TEXT EMACS CHCLIP
bind:addkey ted_emacs <Key-F16> copy {edc:copy %W}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-backslash> deselect {
    %W tag remove sel 1.0 end
}

# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-slash> select-all {
	edc:select-all %W
}


# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Shift-Key-space> select-to-here {
    set tkPriv(selectMode) char
    tkTextKeyExtend %W insert
}


# TEXT EMACS MOVE
bind:addkey ted_emacs <Control-Key-space> select-from-here {
    %W mark set anchor insert
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-BackSpace> delete-previous-char {
    if {[%W tag nextrange sel 1.0 end] != ""} {
	%W delete sel.first sel.last
    } elseif [%W compare insert != 1.0] {
	%W delete insert-1c
    }
	eda:update %W
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-Delete> delete-next-char {
    if {[%W tag nextrange sel 1.0 end] != ""} {
	%W delete sel.first sel.last
    } else {
	%W delete insert
    }
	eda:update %W
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-Return> insert-return {
    edc:insertkey %W \n
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-i> insert-tab {
    edc:insertkey %W \t
}


# TEXT EMACS CHANGE
bind:addkey ted_emacs <Key-Tab> insert-tab {
    edc:insertkey %W \t
    focus %W
    break
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-bracketleft> shift-left {
    edc:shift-left %W 
}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-Key-bracketright> shift-right {
    edc:shift-right %W 
}


# -----------------------------------------------------------------------------
# Buttons 
# -----------------------------------------------------------------------------

# TEXT MOTIF CHANGE
bind:addbutton ted_emacs <ButtonRelease-2> mouse-paste-sel {
    if {!$tkPriv(mouseMoved) || $tk_strictMotif} {
	tkTextPaste %W %x %y
# TMP:
	eda:update %W pasfini
    }
}


#
# FRED:
#

# TEXT MOTIF CHANGE
bind:addbutton ted_emacs <Double-Button-3> mouse-cut-paste {
	set tkPriv(selectMode) char
	%W mark set insert current
	tk_textCut %W
	edc:paste %W
}

# MENU FILE:

# TEXT MOTIF MISC
bind:addkey ted_emacs <Control-x>n New {ed:New %W}

# TEXT MOTIF MISC
bind:addkey ted_emacs <Control-x>s Save {ed:Save %W}

# TEXT MOTIF MISC
bind:addkey ted_emacs <Control-x>S SaveAs {ed:SaveAs %W}

# TEXT MOTIF MISC
bind:addkey ted_emacs <Control-x>w Close {ed:Close %W}


# MENU FIND:
# TEXT EMACS MISC
bind:addkey ted_emacs <Control-x>f dial-find  {ed:dial-find %W}

# TEXT EMACS MISC
bind:addkey ted_emacs <Control-x>g find-next  {ed:find-next %W}

# TEXT EMACS MISC
bind:addkey ted_emacs <Control-x>G find-selection  {ed:find-selection %W}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-x>r replace {ed:replace %W}

# TEXT EMACS CHANGE
bind:addkey ted_emacs <Control-x>R replace-then-find {ed:replace-then-find %W}

# MENU SYNTAX:
# TEXT EMACS MISC
bind:addkey ted_emacs <Control-x>k check-syntax  {ed:check-syntax %W}


# -- EOF emacs.tcl ----------------------------------------------------------
