# -- gd3.tcl
# Le debugger visuel de Prolog IV (arbres d'execution)
#
# Auteur:		Pascal Bouvier
# Creation:		1998
# Modifications:	(nombreuses)
#
# (c) PrologIA 1998-2000
# -----------------------------------------------------------------------------



global tcl_platform

global callx cally d32 d16 d8 d4
global zoom
global winzoom
global gd:allrules
global curlevel calllevel
global rightmost
global tabentoure
global ancetre lastanc tabcall tabokrule tabsuiv prec tabnames
global gd:vdoc gd:vdoczoom
set gd:vdoc 0
set gd:vdoczoom 0
global gd:doall
global gd:winzoom_x gd:winzoom_y

global the_exec_list
set the_exec_list {}

catch {unset tabentoure}
catch {unset ancetre}
set winzoom 400

global gd:replaymode
set gd:replaymode 0

# ------------------------------------------------------------------------------
# A appeler au debut
# ------------------------------------------------------------------------------
proc gd:init {} {
	set w .gd
	toplevel $w ; wm withdraw $w
	wm title $w [lang: T-gdebug]
	wm minsize $w  1 1
	canvas $w.c -bg #e0ffe0 -width 20c -hei 12c
	global $w.l.v
	set $w.l.v "0:0"

	set fm $w.fmenu
	frame $fm
		set mb $fm.mb
		set m $mb.m
		menubutton $mb -menu $m -text [lang: GD.M-misc]
			menu $m
			$m add command -label [lang: load-exec-tree] -command gd:loadtree
			$m add sepa
			$m add checkbutton -label [lang: show-names] -variable gd:vdoc \
				-command "gd:documente $w.c \${gd:vdoc}"
			$m add checkbutton -label [lang: replay-mode] -variable gd:replaymode
			$m add checkbutton -label [lang: replay-left-mode] -variable gd:doall
			set mm $m.mnames
			$m add cascade -label [lang: names-submenu] -menu $mm
			menu $mm
				
		button $fm.bclear -text [lang: GD.clear] -command gd:clear -padx 3
		checkbutton $fm.cballtries -text [lang: GD.show-all-tries] \
			-variable gd:allrules -padx 3
		checkbutton $fm.cbreplay -text [lang: GD.replay] \
			-variable gd:replaymode -padx 3
		checkbutton $fm.cbdoc -text [lang: GD.names] \
			-command "gd:documente $w.c \${gd:vdoc}" \
			-variable gd:vdoc -padx 3
		#
		button $fm.borg -text "O" -command "gd:origine" -padx 3
		button $fm.zin -text "Z+" -command "gd:+" -padx 3
		button $fm.zou -text "Z-" -command "gd:-" -padx 3
		pack $mb $fm.bclear $fm.cballtries $fm.cbreplay $fm.cbdoc -side left
		pack $fm.zin $fm.zou $fm.borg -side right
	pack $fm -side top -fill x

	frame $w.fbot
	label $w.l -width 32 -textvar $w.l.v -text "-"
	pack $w.fbot -side bottom -fill x
	frame $w.grow -width 18 -relief raised
	scrollbar $w.sv -orient vert  -relief sunken
	scrollbar $w.sh -orient horiz -relief sunken

	pack $w.l -in $w.fbot -side left
	pack $w.sh  -in $w.fbot -fill x -side left -expand 1
	pack $w.grow -in $w.fbot -side left
	pack $w.c -side left -fill both -expand 1
	pack $w.sv -side left -fill both

	$w.c config -xscrollcom "$w.sh set"
	$w.c config -yscrollcom "$w.sv set"
	$w.c config -scrollreg {-70000 -20 70000 20000}
	$w.c config -selectbor 2 -selectba pink -selectfor blue
	$w.c config -xscrollincr 10
	$w.c config -yscrollincr 10
	$w.sv config -command "$w.c yview"
	$w.sh config -command "$w.c xview"

	bind $w.c <B2-Motion> {.gd.c scan dragto %x %y;  }
	bind $w.c <Button-2> {.gd.c scan mark %x %y;  }
#	bind $w.c <Motion> {set .gd.l.v [format "%%d : %%d" %x %y]}
	bind $w.c <Motion> {set .gd.l.v [gd:nodename]}
	bind $w.c <Control-Button-1> {gd:winzoom %x %y}
	bind $w.c <Shift-Button-1> {gd:choosenode %W}
	
	gd:reinit
}

# ------------------------------------------------------------------------------
# Pour faire apparaitre la fenetre a l'ecran
# ------------------------------------------------------------------------------
proc gd:show_exec_window {} {
	wm deiconify .gd
}

#
# gd:zoominit
#
proc gd:zoominit {} {
	global winzoom
	set w .gdzoom
	toplevel $w
	wm title $w [lang: T-gdzoom]
	wm minsize $w 1 1
#	wm maxsize $w $winzoom $winzoom
	wm protocol $w WM_DELETE_WINDOW ".gd.c delete miniscreen; destroy $w"
	set fm [frame $w.fm]
		checkbutton $fm.cbdoc -text [lang: GDZ.names] \
			-command "gd:documente $w.c \${gd:vdoczoom}" \
			-variable gd:vdoczoom -padx 3
		pack $fm.cbdoc
	canvas $w.c -bg #d0ffd0 -height $winzoom -width $winzoom
	pack $fm -side top
	pack $w.c -side top -fill both -expand yes
	$w.c create line -10 -10 -10 -10 -tags {bas}
	bind $w.c <Motion> {set .gd.l.v [gd:nodename %W]}
	bind .gd.c <Button-3> {
		puts "%x;%y ([expr {%x+[%W canvasx 0]}]:[expr {%y + [%W canvasy 0]}]): [%W find withtag current]"
		}
	}

#
# On a clique en x y
#
proc gd:winzoom {x y} {
	global gd:winzoom_x gd:winzoom_y
	set w .gdzoom.c
	if {![winfo exists $w]} gd:zoominit

	set wo .gd.c
	set x [expr {$x + [$wo canvasx 0]}]
	set y [expr {$y + [$wo canvasy 0]}]

	set gd:winzoom_x $x
	set gd:winzoom_y $y

	gd:winzoom_work $w $wo $x $y
}

#
# On s'est deplace en direction dir
#
proc gd:winzoom_move {where} {
	global zoom winzoom gd:winzoom_x gd:winzoom_y

	set w .gdzoom.c
	set wo .gd.c
	set x [expr {${gd:winzoom_x} + [$wo canvasx 0]}]
	set y [expr {${gd:winzoom_y} + [$wo canvasy 0]}]

	set d [expr {double($winzoom)*$zoom}]
	switch -- $where {
		n {set y [expr {$y - $d/2.0}]}
		s {set y [expr {$y + $d/2.0}]}
		e {set x [expr {$x + $d/2.0}]}
		w {set x [expr {$x - $d/2.0}]}
		ne {set y [expr {$y - $d/2.0}] ; set x [expr {$x + $d/2.0}]}
		se {set y [expr {$y + $d/2.0}] ; set x [expr {$x + $d/2.0}]}
		nw {set y [expr {$y - $d/2.0}] ; set x [expr {$x - $d/2.0}]}
		sw {set y [expr {$y + $d/2.0}] ; set x [expr {$x - $d/2.0}]}
		}

	set gd:winzoom_x $x
	set gd:winzoom_y $y

	gd:winzoom_work $w $wo $x $y
}


#
#
#
proc gd:winzoom_work {w wo x y} {
	global zoom winzoom

	set d [expr {double($winzoom)*$zoom}]

	set x1 [expr {$x + $d/2.0}]
	set y1 [expr {$y + $d/2.0}]
	set x  [expr {$x - $d/2.0}]
	set y  [expr {$y - $d/2.0}]

	errputs "z $zoom x: $x y: $y x1:$x1 y1:$y1"
	set miniscreen [$wo find withtag miniscreen]
	if {"$miniscreen" == ""} {
		set miniscreen [$wo create rect $x $y $x1 $y1 \
			-fill yellow -outline orange -tag miniscreen]
		$wo lower $miniscreen
		} \
	else {
		$wo coord $miniscreen $x $y $x1 $y1
		}
	set L [$wo find overlapping $x $y $x1 $y1]
	$w delete all
	$w create line -10 -10 -10 -10 -tags {bas}
	foreach i $L {
#		set lcoord [$wo coords $i]
#		set x0 [lindex $lcoord 0]
#		set y0 [lindex $lcoord 1]
#		set x1 [lindex $lcoord 2]
#		set y1 [lindex $lcoord 3]
#		set j [$w create [$wo type $i] $x0 $y0 $x1 $y1]

		if {[lsearch -exact [$wo gettags $i] entoure] != -1} continue

		set j [copier_itemcanvas $wo $i $w]
		$w move $j [expr {-$x}] [expr {-$y}]
		set z [expr {1.0/$zoom}]
		$w scale $j 0 0 $z $z
		}
	$w delete miniscreen
	$w delete doc

	global tabentoure
	foreach pred [array names tabentoure] {
		gd:entoure $pred $tabentoure($pred) $w
		}
		
	global gd:vdoczoom
	gd:documente $w ${gd:vdoczoom}
		
	wm deiconify .gdzoom
	raise .gdzoom
}

#
#
#
proc gd:reinit {} {
	global callx cally d32 d16 d8 d4 zoom curlevel rightmost
	global gd:allrules
	global calllevel last
	global lastanc ancetre tabcall tabokrule tabsuiv prec
	global tabentoure
	global gd:replaymode gd:vdoc gd:vdoczoom
	global gd:doall

	set callx 0
	set cally 0
	set d32 16
	set d16 8
	set d8 4
	set d4 2
	set zoom 1
	set gd:allrules 1
	set curlevel 0
	set calllevel 0
	set rightmost 0
	set last ""
	.gd.c create line -10 -10 -10 -10 -tags {bas}
	catch {unset ancetre}
	catch {unset tabcall}
	catch {unset tabokrule}
	catch {unset tabsuiv}
	catch {unset tabentoure}
	set lastanc 0
	set prec 0
	set gd:replaymode 0
	set gd:vdoc 0
	set gd:vdoczoom 0
	gd:clearnames
	set gd:doall 1
	global the_exec_list
	set the_exec_list {}
}

proc gd:clear {} {
	.gd.c delete all
	catch ".gdzoom.c delete all"
	gd:reinit
}


proc gd:+ {} {
	global callx cally d32 d16 d8 d4 zoom
	set zoom [expr {$zoom * 2}]
	set callx [expr {$callx * 2}]
	set cally [expr {$cally * 2}]
	set d32 [expr {$d32 * 2}]
	set d16 [expr {$d16 * 2}]
	set d8 [expr {$d8 * 2}]
	set d4 [expr {$d4 * 2}]

	set w .gd.c

	set incx [$w cget -xscrollincrement]
	set incy [$w cget -yscrollincrement]
	$w config -xscrollincrement 1
	$w config -yscrollincrement 1
	
	set x0 [$w canvasx 0]
	set y0 [$w canvasy 0]
	$w scale all 0 0 2 2
	# essai:
	set x1 [$w canvasx 0]
	set y1 [$w canvasy 0]
	$w xview scroll [expr {-int($x1-$x0*2)}] u
	$w yview scroll [expr {-int($y1-$y0*2)}] u

	$w config -xscrollincrement $incx
	$w config -yscrollincrement $incy

	$w delete entoure
	global tabentoure
	foreach pred [array names tabentoure] {
		gd:entoure $pred $tabentoure($pred) $w
		}
}

proc gd:- {} {
	global callx cally d32 d16 d8 d4 zoom
	set zoom [expr {$zoom / 2.0}]
	set callx [expr {$callx / 2.0}]
	set cally [expr {$cally / 2.0}]
	set d32 [expr {$d32 / 2.0}]
	set d16 [expr {$d16 / 2.0}]
	set d8 [expr {$d8 / 2.0}]
	set d4 [expr {$d4 / 2.0}]

	set w .gd.c

	if {$zoom < 0.5} {
		# on enleve les noms si ca devient trop petit
		gd:documente $w 0
		}

	set incx [$w cget -xscrollincrement]
	set incy [$w cget -yscrollincrement]
	$w config -xscrollincrement 1
	$w config -yscrollincrement 1
		
	set x0 [$w canvasx 0]
	set y0 [$w canvasy 0]
	$w scale all 0 0 0.5 0.5 
	set x1 [$w canvasx 0]
	set y1 [$w canvasy 0]
	$w xview scroll [expr {-int($x1-$x0*0.5)}] u
	$w yview scroll [expr {-int($y1-$y0*0.5)}] u

	$w config -xscrollincrement $incx
	$w config -yscrollincrement $incy

	$w delete entoure
	global tabentoure
	foreach pred [array names tabentoure] {
		gd:entoure $pred $tabentoure($pred) $w
		}
}

#
#
#
proc gd:origine {} {
	set incx [.gd.c cget -xscrollincrement]
	set incy [.gd.c cget -yscrollincrement]
	.gd.c config -xscrollincrement 1
	.gd.c config -yscrollincrement 1
	
	set x0 [.gd.c canvasx 0]
	set y0 [.gd.c canvasy 0]
	.gd.c xview scroll [expr {-int($x0)}] u
	.gd.c yview scroll [expr {-int($y0)}] u

	.gd.c config -xscrollincrement $incx
	.gd.c config -yscrollincrement $incy
}

#
#
#
proc gd:addname {s} {
	set w .gd
	set m .gd.fmenu.mb.m.mnames
	set mc [menu $m.mcoul-$s]
		$mc add command -label [lang: GD.nocolor] \
			-command "gd:entoure $s {-none-} ; $m entryconf $s -backg {}"
		foreach coul {red blue green yellow purple orange} {
			$mc add command -label "      " -foreg $coul -backg $coul \
				-command "gd:entoure $s $coul ; $m entryconf $s -backg $coul"
			}
global tk_version
if {$tk_version >= 8.0} {
	$m add cascade -label $s -menu $mc \
		-columnbreak [expr {([$m index last] % 30) == 29}]
	} \
else {
	$m add cascade -label $s -menu $mc
	}

}

#
#
#
proc gd:clearnames {} {
	global tabnames tabentoure
	catch {unset tabnames}
	catch {unset tabentoure}
	catch {.gd.c delete entoure}
	set m .gd.fmenu.mb.m.mnames
	$m delete 0 end
	eval destroy [winfo child $m]
}

#
#
#
proc gd:nodename {{W .gd.c}} {
	set p ""
	set r ""
	set n ""
	set l ""
	
	set L [$W gettags current]
	if {[set i [lsearch $L p-*]] != -1} {
		set p [lindex $L $i]
		regexp p-(.*) $p _ p
		}
	if {[set i [lsearch $L r-*]] != -1} {
		set r [lindex $L $i]
		regexp r-(.*) $r _ r
		}
	if {[set i [lsearch $L n-*]] != -1} {
		set n [lindex $L $i]
		regexp n-(.*) $n _ n
		}
	if {[set i [lsearch $L l-*]] != -1} {
		set l [lindex $L $i]
		regexp l-(.*) $l _ l
		}
	return "$p $r ($n) <$l>"
}

proc gd:oldnodename {} {
	return [.gd.c gettags current]
}

proc gd:select {pred {color red}} {
	foreach i [.gd.c find withtag p-$pred] {
		.gd.c itemconf $i -fill $color
		}
}

proc gd:entoure {pred {color red} {W .gd.c}} {
	global tabentoure
	
	if {$color == "-none-"} {
		catch {unset tabentoure($pred)}
		$W delete e-$pred
		return
		}
	
	set tabentoure($pred) $color
	foreach i [$W find withtag p-$pred] {
		set r [$W coord $i]
		set x1 [lindex $r 0]
		set y1 [lindex $r 1]
		set x2 [lindex $r 2]
		set y2 [lindex $r 3]
		set e [$W create oval \
			[expr {$x1-5}] [expr {$y1-5}] \
			[expr {$x2+5}] [expr {$y2+5}] \
			-fill $color -outline $color \
			-stipple gray50 -tag [list entoure e-$pred]]
		$W lower $e bas
		}
}

global gd:font
if {$tcl_platform(platform) == "unix"} {
	set gd:font "-Adobe-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*"
	} \
else {
	# Sur PC :
	set gd:font {helvetica 10 ""}
	}

# -----------------------------------------------------------------------------
# Affiche le nom des predicats dans le canvas
# -----------------------------------------------------------------------------
proc gd:documente {{C .gd.c} {bool 1}} {
	global gd:font d8 d16
	if {$bool == 0} {
		$C delete doc
		} \
	else {
		foreach i [$C find withtag call] {
			set L [$C gettags $i]
			if {[set idx [lsearch $L p-*]] != -1} {
				set p [lindex $L $idx]
				set p [string range $p 2 end]
				}
			set L [$C coord $i]
			set x [lindex $L 0]
			set y [lindex $L 1]
			if {$C == ".gd.c"} {
				set itx [$C create text [expr {$x + $d16 +$d8}] [expr {$y + $d16}] \
					-text $p -anc w -tag doc -font ${gd:font} -fill blue]
				} \
			else {
				set itx [$C create text [expr {$x + 8 +4}] [expr {$y + 8}] \
					-text $p -anc w -tag doc -font ${gd:font} -fill blue]
				}
			$C lower $itx $i
			}
		}
}

proc gd:print {} {
.gd.c postscript -rotate yes -file f.ps -pagewidth 20c -width 5600 -hei 3600
}

#
# Le port CALL
#
proc OKgd:call {n s l} {
	global callx cally d32 d16 d8
	set g .gd.c
	set cally [expr {$cally + $d32}]
	$g create line $callx $cally $callx [expr {$cally-$d32}] -tag vligne
	$g create rect $callx $cally [expr {$callx+$d16}] [expr {$cally+$d16}] \
		-tag [list p-$s n-$n r-0 c-$n l-$l call] \
		-fill {}
		-fill white
}

#
# Le port CALL
#

proc gd:call {n s l} {
	if [catch {gda:call $n $s $l} u] {
		wputs "error dans {gdcall $n $s $l} : $u"
		}
}

proc gda:call {n s l} {
	global callx cally d32 d16 d8 d4 curlevel last calllevel
	global ancetre lastanc tabcall tabsuiv prec tabnames
	set g .gd.c
	$g delete up
	
	if ![info exists tabnames($s)] {
		# on cree le menu pour ce nom
		set tabnames($s) $n
		gd:addname $s
		}
	
	if {$last == "call"} {
		set curlevel $calllevel
		}
	if {$l != $curlevel} {
		# on monte les niveaux (trait vers le haut)
		set yy [expr {$cally + ($l-$curlevel)*$d32 -$d4}]
		set it [$g create line $callx $cally $callx $yy \
			-tag [list vligne ll-$curlevel]]
		set ancetre($it) $lastanc
		set lastanc $it
		set cally $yy
		} \
	else {
		}
	set xx [expr {$callx - $d32}]
	set yy [expr {$cally + $d32}]
	set it [$g create line $callx $cally $xx $yy \
		-tag [list vligne ll-$l]]
	set ancetre($it) $lastanc
	set lastanc $it
	set callx $xx
	set cally $yy
	set fill [expr [string compare $s "green/0"] ? {"orange"} : {"green"}]
	set it [$g create rect $callx $cally [expr {$callx+$d16}] [expr {$cally+$d16}] \
		-tag [list p-$s n-$n r-0 c-$n l-$l call] \
		-fill $fill]
	set ancetre($it) $lastanc
	set lastanc $it
	set tabcall($n) $it
	set tabsuiv($prec) $n

# test avec polygone:
#	$g create polygon $callx $cally [expr {$callx+$d16}] [expr {$cally-$d16}] \
#		[expr {$callx+$d16}] [expr {$cally+$d16}] \
#		$callx [expr {$cally+$d32}] $callx $cally \
#		-tag [list p-$s n-$n r-0 c-$n l-$l call] \
#		-fill $fill -outline gray50

	set calllevel $l
	set last call
	if {$n % 50 == 0} update
}

#
# Si avant, il y a r-0, c'est le premier ok d'un call
# sinon, il faut faire un frere (autre regle)
# Si NON "show all tries" on fait les OK mais pas les RULE.
#
proc gd:ok {n s r l} {
	global gd:allrules
	if {${gd:allrules} == 0} {
		gd:okrule $n $s $r $l
		}
	gd:succ $l
}

#
# Si avant, il y a r-0, c'est le premier ok d'un call
# sinon, il faut faire un frere (autre regle)
# gd:rule ressemble a ok, mais quand on fait l'un on ne fait pas l'autre
# Si "show all tries" on fait les RULE mais pas les OK.
#
proc gd:rule {n s r l} {
	global gd:allrules
	if {${gd:allrules} == 0} return
	gd:okrule $n $s $r $l
}

#
# Bouts communs a OK et RULE
#
proc gd:okrule {n s r l} {
	global callx cally d32 d16 d8 d4 curlevel last rightmost
	global ancetre lastanc tabokrule prec
	set g .gd.c
	$g delete up

	set t [$g find withtag c-$n]
	if { $t == "" } {
		set it $t
		} \
	elseif {[lsearch -exact [$g gettags $t] r-0] == -1} {
		# c'est un frere, a creer a cote
		incr rightmost
		set Coords [$g coords $t]
		set x [lindex $Coords 0]
		set y [lindex $Coords 1]
		set callx [expr {$rightmost*(2*$d32+$d16) -($y-$l*$d32 + $d32)}] ;# `+ $d32` PBO 30/11/1999
		set cally [expr {$y + $d32 + $d4}]
		set it [$g create line $x $cally $callx $cally \
			-tag [list hligne ll-$l]]
#		set cally [expr {$cally - $d8/2}]
		$g lower $it $t
		set ancetre($it) $t
		} \
	else {
		# c'est la premiere tentative
		$g dtag $t r-0
		set Coords [$g coords $t]
		set x [lindex $Coords 0]
		set y [lindex $Coords 1]
		set cally [expr {$y + $d32 + $d4}]
		set it [$g create line $x $y $x $cally \
			-tag [list vligne ll-$l]]
		set ancetre($it) $t
		}
	set lastanc [$g create rect $callx $cally [expr {$callx+$d8}] [expr {$cally+$d8}] \
		-tag [list n-$n p-$s r-$r l-$l rule] \
		-fill white]
	set ancetre($lastanc) $it
	lappend tabokrule($n) $lastanc $r
	set prec "$n-$r"
	set curlevel $l
	set last ok
}

#
#
#
proc gd:succ {l} {
	global callx cally d8
	global ancetre lastanc
	set x [expr {$callx - $d8}]
	set y [expr {$cally + $d8}]
	set it [.gd.c create line $callx $cally $x $y -tag [list swligne ll-$l]]
	set ancetre($it) $lastanc
	set lastanc $it
	set callx $x
	set cally $y
}


#
# Bouts communs a OK et RULE
#
proc OKgd:okrule {n s r l} {
	global callx cally d32 d16 d8 
	set g .gd.c
	set t [$g find withtag c-$n]
	if { $t == "" } {
		} \
	elseif {[lsearch -exact [$g gettags $t] r-0] == -1} {
		# c'est un frere, a creer a cote
		set callx [expr {$callx + $d32}]
		set x [lindex [$g coords $t] 0]
		set y [lindex [$g coords $t] 1]
		set cally $y
		$g create line $x $y $callx $cally -tag hligne
		} \
	else {
		$g dtag $t r-0
#		errputs "tags ($t)"
		}
	$g create rect $callx $cally [expr {$callx+$d8}] [expr {$cally+$d8}] \
		-tag [list n-$n p-$s r-$r l-$l rule] \
		-fill {}
}


proc gd {} {
	gd:call 1 to_begin/0	
	gd:ok   1 to_begin/0 1
	gd:call 2 lightMeal/3	
	gd:ok 2 lightMeal/3	 1
	gd:call 3 horsdoeuvre/3	
	gd:ok 3 horsdoeuvre/3 1	
	gd:call 4 maincourse/2	
	gd:ok 4 maincourse/2	 1
	gd:call 5 meat/2	
	gd:ok 5 meat/2	1
	gd:call 6 dessert/2	
	gd:ok 6 dessert/2	1
	gd:ok 6 dessert/2	2
	gd:ok 6 dessert/2	3
	gd:ok 5 meat/2	2
	gd:call 7 dessert/2	
	gd:ok 7 dessert/2	1
	gd:ok 7 dessert/2	2
	gd:ok 7 dessert/2	3
	gd:ok 4 maincourse/2	 2
	gd:call 8 meat/2	
	gd:ok 8 meat/2	1
	gd:call 9 dessert/2	
	gd:ok 9 dessert/2	1
	gd:ok 9 dessert/2	2
	gd:ok 9 dessert/2	3
	gd:ok 8 meat/2	2
	gd:call 10 dessert/2	
	gd:ok 10 dessert/2	1
	gd:ok 10 dessert/2	2
	gd:ok 10 dessert/2	3
	gd:call 11 write/1	
	gd:call 12 nl/1	
}

proc gd:clearup {} {.gd.c delete up exec}

proc dbgcom:showgraf_CALL {s a nb ab l r} {
	global gd:replaymode 
	if ${gd:replaymode} { gd:replay_call $ab $s/$a $l } \
	else { gd:call $ab $s/$a $l }
	}
proc dbgcom:showgraf_OK   {s a nb ab l r} {
	global gd:replaymode 
	if ${gd:replaymode} { gd:replay_ok $ab $s $r $l } \
	else { gd:ok $ab $s $r $l }
	}
proc dbgcom:showgraf_EXIT {s a nb ab l r} { gd:clearup ; gd:step}
proc dbgcom:showgraf_EXITED {s a nb ab l r} {
	global gd:replaymode
	incr l
	if ${gd:replaymode} { gd:replay_exited $ab $s $r $l } \
	else { gd:okrule $ab $s $r $l; gd:succ $l }
	}
proc dbgcom:showgraf_REDO {s a nb ab l r} { gd:clearup ; gd:step}
proc dbgcom:showgraf_FAIL {s a nb ab l r} { gd:clearup ; gd:step}
proc dbgcom:showgraf_RULE {s a nb ab l r} { 
	global gd:replaymode 
	if ${gd:replaymode} { gd:replay_rule $ab $s $r $l } \
	else { gd:rule $ab $s $r $l }
	}
proc dbgcom:showgraf_CALLER {s a nb ab l r} {
	puts "<|$s:$a:$nb:$ab:$l:$r"
	set g .gd.c
	$g delete up
#	if {$r == 0} { # call}
	if 1 {
		set cit [$g find withtag c-$ab]
		gd:cadre $g $cit blue
		}
}
proc dbgcom:showgraf_CURR {s a nb ab l r} {
	puts "||$s:$a:$nb:$ab:$l:$r"
	set g .gd.c
	$g delete up
	if {$r == 0} { # call
		set cit [$g find withtag c-$ab]
		gd:cadre $g $cit purple3
		} \
	else { # ok ou rule
		set lit [$g find withtag n-$ab]
		foreach it $lit {
			set tags [$g gettags $it]
			if {[lsearch -exact $tags "r-$r"] >= 0} {
				gd:cadre $g $it purple3
				break
				}
			}
		}
}

proc gd:step {} {
	global gd:doall gd:replaymode
	if { ${gd:replaymode}  &&  !${gd:doall} } {
		dbg:envoie "s \n"
		}
}

# -----------------------------------------------------------------------------
# Pour le replay
# -----------------------------------------------------------------------------
proc gd:replay_call {ab sa l} {
	set g .gd.c
	global the_exec_list gd:doall
	
	if !${gd:doall} {
		if [llength $the_exec_list]==0 {
			set gd:doall 1
			} \
		else {
			set tr [lindex $the_exec_list 0]
			set pred [lindex $tr 0]
			set abs [lindex $tr 1]
			set rule [lindex $tr 2]
			if {$pred != $sa} return
			dbg:envoie "absbox $abs \n"
			set ab $abs
			if {$rule == ""} {
				set gd:doall 1
				}
			}
		}
	
	set it [$g find withtag c-$ab]
	gd:cadre $g $it red exec
	if !${gd:doall} {
		dbg:envoie "s \n"
		}
}

# -----------------------------------------------------------------------------
# Pour le replay
# -----------------------------------------------------------------------------
proc gd:replay_okrule {ab s r l} {
	set g .gd.c
	set lit [$g find withtag n-$ab]
	foreach it $lit {
		set tags [$g gettags $it]
		if {[lsearch -exact $tags "r-$r"] >= 0} {
			gd:cadre $g $it red exec
			break
			}
		}
}

# -----------------------------------------------------------------------------
# Pour le replay
# -----------------------------------------------------------------------------
proc gd:replay_rule {ab s r l} {
	global gd:doall the_exec_list
	if !${gd:doall} {
		set tr [lindex $the_exec_list 0]
		set pred [lindex $tr 0]
		set abs [lindex $tr 1]
		set rule [lindex $tr 2]
		if {$pred != $s} return
		if {$rule == ""} { # ajout != "" c'est un CALL
			return
			} \
		elseif {$rule != $r} {
			dbg:envoie "rule $rule \n"
			return
			} \
		else {
			set the_exec_list [lrange $the_exec_list 1 end]
			if [llength $the_exec_list]!=0 {
				dbg:envoie "s \n"
				}
			}
		}
	gd:replay_okrule $ab $s $r $l
}

# -----------------------------------------------------------------------------
# Pour le replay
# -----------------------------------------------------------------------------
proc gd:replay_ok {ab s r l} {
	gd:replay_okrule $ab $s $r $l

	global gd:doall
	if !${gd:doall} {
		dbg:envoie "s \n"
		}
}

# -----------------------------------------------------------------------------
# Pour le replay
# -----------------------------------------------------------------------------
proc gd:replay_exited {ab s r l} {
	gd:replay_okrule $ab $s $r $l

	global gd:doall
	if !${gd:doall} {
		global the_exec_list
		set the_exec_list [lrange $the_exec_list 1 end]
		dbg:envoie "s \n"
		}
}



# -----------------------------------------------------------------------------
# Met un cadre autour de la boite (call ou ok/rule) it,
# avec son nom a cote. (en bleu)
# RETOUR: aucun
# -----------------------------------------------------------------------------
proc gd:cadre {W it coul {ptag up}} {
	set rect [gd:enlarge [$W coord $it] 10]
	$W delete $ptag up
	set nit [eval $W create rectangle $rect -outline $coul -width 2 -tags $ptag]
	$W lower $nit $it
	#
	# Ce qui suit est pour le nom du noeud
	#
	set x [expr {[lindex $rect 2] + 5}]
	set y [lindex $rect 3]
	set tags [$W gettags $it]
	set pos [lsearch -glob $tags "p-*"]
	if {$pos >= 0} {
		set pred [string range [lindex $tags $pos] 2 end]
		$W create text $x $y -anch sw -text $pred \
			-tags $ptag -fill $coul
		}
	update
}

# -----------------------------------------------------------------------------
# Agrandi un rectangle rect de wid pixels dans les 4 directions.
# RETOUR : le rectangle resultat
# -----------------------------------------------------------------------------
proc gd:enlarge {rect wid} {
        return [list [expr {[lindex $rect 0]-$wid}] \
                        [expr {[lindex $rect 1]-$wid}] \
                        [expr {[lindex $rect 2]+$wid}] \
                        [expr {[lindex $rect 3]+$wid}] ]
}


#
#
#
proc gd:colorlevel {{w .gd.c}} {
	for {set i 0} {$i <= 15} {incr i} {
		set col [format "#%02x%02x%02x" 0 [expr {255 -$i *16}] 0]
		$w addtag sel withtag l-$i
		catch {$w itemconf sel -fill $col -outline $col}
		$w dtag sel
		$w addtag sel withtag ll-$i
		catch {$w itemconf sel -fill $col}
		$w dtag sel
		}
	for {set i 16} {$i <= 31} {incr i} {
		set col [format "#%02x%02x%02x" 0 0 [expr {255 -($i-16) *16}]]
		$w addtag sel withtag l-$i
		catch {$w itemconf sel -fill $col -outline $col}
		$w dtag sel
		$w addtag sel withtag ll-$i
		catch {$w itemconf sel -fill $col}
		$w dtag sel
		}
}


# -----------------------------------------------------------------------------
# Dessine la branche de la demonstration en remontant jusqu'a la racine
# a partir de l'item id, dont l'id est itorg.
# -----------------------------------------------------------------------------
proc gd:branche {id itorg} {
	global ancetre
	
	puts "branche>>> $id $itorg"
	set g .gd.c
	$g delete branche
	$g dtag thebranch
	
	set L {}
	
	set it $itorg
	$g addtag thebranch withtag $it
	set coord [$g coord $it]
	lappend L [lindex $coord 0] [lindex $coord 1]

	for {set it $id} {$it >= 2} {set it $ancetre($it)} {
		if {[lsearch -exact [$g gettags $it] rule] >= 0} {
			$g addtag thebranch withtag $it
			}
		set coord [$g coord $it]
		lappend L [lindex $coord 0] [lindex $coord 1]
		}
	eval $g create line $L -width 3 -fill green -tags branche
	$g lower branche
}

proc gd:choosenode {W} {
	set n ""
	set itorg [$W find withtag current]
	set L [$W gettags current]
	if {[set i [lsearch $L n-*]] != -1} {
		set n [lindex $L $i]
		regexp n-(.*) $n _ n
		}
	global tabcall
	gd:branche $tabcall($n) $itorg
	gd:dumpbranch
	return $n
}

proc gd:dumpbranch {} {
	set g .gd.c
	global the_exec_list
	set the_exec_list {}
	foreach it [$g find withtag thebranch] {
		set tags [$g gettags $it]
		set pred [string range [lindex $tags [lsearch -glob $tags "p-*"]] 2 end]
		set rule [string range [lindex $tags [lsearch -glob $tags "r-*"]] 2 end]
		set abs  [string range [lindex $tags [lsearch -glob $tags "n-*"]] 2 end]
		puts "$pred ; $rule ; $abs"
		lappend the_exec_list [list $pred $abs $rule]
		}
}

proc gd:loadtree {} {
	set fname [tk_getOpenFile]
	if [string len $fname] {
		gd:clear
		catch {source $fname}
		}
}


proc OLDgd:branche {id} {
	global ancetre
	
	set g .gd.c
	$g dtag branche
	for {set it $id} {$it >= 2} {set it $ancetre($it)} {
		if {[$g type $it] == "line"} {
			$g itemconf $it -width 2 -fill blue
			} \
		else {
			$g itemconf $it -width 2 -outline blue
			}
		$g addtag branche withtag $it
		}
}

#
#
#
proc gd:initshowvar {var} {
	set w .topv
	catch { set top .topv
		toplevel $top
		wm title $top "Variables"
		set f [frame $top.f]
		pack $f -side top -fill x -expand y
		button $f.bcont -text "Cont." -command "set gd:cont 1"
		button $f.bfail -text "fail" -command "set gd:cont -1"
		pack $f.bcont $f.bfail -side left -fill both -expand y
		} 
	catch {
		upvar #0 var-$var thevar
		set thevar 1
		set wc [checkbutton $w.cb$var -text "Watch $var" -variable var-$var]
		set wm [label $w.l$var -text "$var : " -width 30 -relief sunken]
		pack $wc $wm -side top -fill both -expand y
		}
}

proc gd:showvar {var value {a1 -}} {
	set top .topv
	set w $top.l$var
	set oval [$w cget -text]
	$w config -text "$oval\n($a1)  :  $value"
	upvar #0 var-$var thevar
	if $thevar {
		global gd:cont
		tkwait variable gd:cont
		return "success(${gd:cont}). "
		}
	return "success(1). "
}


#-- EOF gd3.tcl ---------------------------------------------------------
