
global tcl_platform

#
# Vraiment tres simple
#

if {$tcl_platform(platform) == "unix"} {
	proc i:makefontname {{N courier} {B 0} {I 0} {T 12}} {
		set n [string tolower $N]
		if {$n == "courier" || $n == "helvetica"} { set ita O } else { set ita I }
		if {"$B" == "b"} {set B Bold} else {set B Medium}
		if {"$I" == "i"} {set I $ita} else {set I R}
		return "*-$N-$B-$I-Normal-*-${T}0-*"
	}
} else {
	proc i:makefontname {{N courier} {B 0} {I 0} {T 12}} {
		if {"$B" == "b"} {set B Bold} else {set B ""}
		if {"$I" == "i"} {set I Italic} else {set I ""}
		return [list $N $T "$B $I"]
	}
}

proc i:cleartag {t deb fin} {
	foreach tag [$t tag names] {
		$t tag remove $tag $deb $fin
		}
}

proc i:init {} {
	global i:text
	set top .info
	if [winfo exists $top] {
		wm deiconify $top
		raise $top
		return
		}
	toplevel $top
	set t $top.t
	wm title $top "Information"
	wm minsize $top 0 0

	frame $top.fb
		button $top.fb.bt -text "Top" -command "$t yview 1.0"
		button $top.fb.bb -text "Bottom" -command "$t yview -pickplace end"
		button $top.fb.bc -text "Close" -command "destroy $top"
		pack $top.fb.bt $top.fb.bb -side left -pady 2m
		pack $top.fb.bc -side right -pady 2m -ipadx 5m
	pack $top.fb -side top -fill x -expand yes -padx 1m -pady 1m
	text $t -height 50 -width 70 -relief sunken -bd 2 -wrap word \
			-yscroll "$top.sb set" -cursor ""
	scrollbar $top.sb -orient verti -command "$t yview" -relief sunken
#			-bg #e300f300f500 -activeback #00002e2e0000
	pack $t -side left -fill both -expand yes
	pack $top.sb -side left -fill y

	set i:text $t
	# t0
	$t tag config t0 -font [i:makefontname Helvetica b 0 24] \
			-spacing1 1c -spacing3 1c -justify center
	# t1
	$t tag config t1 -font [i:makefontname Helvetica b 0 18] \
			-spacing1 1c -spacing3 5m
	# t2
	$t tag config t2 -font [i:makefontname Helvetica 0 i 18] \
			-spacing1 5m -spacing3 3m
	# t3
	$t tag config t3 -font [i:makefontname Helvetica b 0 12] \
			-spacing1 2m -spacing3 1m \
			-lmargin1 1c
	# t
	$t tag config t -font [i:makefontname Times 0 0 14] \
			-spacing1 1m -spacing3 1m \
			-lmargin1 1c -lmargin2 0.5c
	# item1
	$t tag config item1 -font [i:makefontname Times 0 0 14] \
			-spacing1 1m -spacing3 1m \
			-lmargin1 1c
	# i1
	$t tag config i1 -font [i:makefontname Times 0 0 14] \
			-spacing3 1m \
			-lmargin1 1.3c -lmargin2 1.3c
	# item2
	$t tag config item2 -font [i:makefontname Times 0 0 14] \
			-spacing1 1m  -spacing3 1m \
			-lmargin1 1.5c
	# i2
	$t tag config i2 -font [i:makefontname Times 0 0 14] \
			-spacing3 1m \
			-lmargin1 1.8c -lmargin2 1.8c
	# tdm
	$t tag config tdm -font [i:makefontname Helvetica 0 0 10] \
			-spacing1 1 -spacing3 1 \
			-lmargin1 1c
	#
	# hypertext
	#
	$t tag config hypertext -underline 1
	$t tag config hilite -backg blue -foreg white
	$t tag bind hypertext <Button-1> { i:hyper:go %W}
	$t tag bind hypertext <Leave> {i:hyper:hiliteoff %W %x %y}
	$t tag bind hypertext <Motion> {i:hyper:motion %W}

	#
	# on lit le fichier d'info
	#
	global srcdir
	eval [i:faccents $srcdir/info.txt]
	$t config -state disabled
}

proc i:faccents {f} {
	set f [open $f r]
	set u [read $f]
	set u [i:doaccents $u]
	close $f
	return $u
}

proc i:t0 {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] t0 \n {}
}

proc i:t1 {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] t1 \n {}
}

proc i:t2 {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] t2 \n {}
}

proc i:t3 {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] t3 \n {}
}

proc i:t {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] t
}

# item 1 -
proc i:i1- {txt} {
	upvar #0 i:text w
	$w insert insert "- " item1 [i:accents $txt] i1
}

proc i:i1 {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] i1
}

# item 2 -
proc i:i2- {txt} {
	upvar #0 i:text w
	$w insert insert "- " item2 [i:accents $txt] i2
}

proc i:i2 {txt} {
	upvar #0 i:text w
	$w insert insert [i:accents $txt] i2
}

#
# Construit le sommaire hypertexte
#
proc i:makesummary {sty} {
	upvar #0 i:text w
	set L [$w tag ranges $sty]

	$w mark set insert summary

	set n 0
	while {! [lempty $L]} {
		set deb [lindex $L 0]
		set fin [lindex $L 1]
		set L [lrange $L 2 end]
		$w tag add tag_$n $deb $fin
		incr n
		}
	for {set i 0} {$i < $n} {incr i} {
		set deb [$w index insert]
		$w insert insert [$w get tag_$i.first tag_$i.last]\n
		i:cleartag $w $deb insert
		$w tag add hypertext $deb insert
		$w tag add tag_$i $deb insert
		$w tag add tdm $deb insert
#		$w insert insert \n
		}
}

#
# Mettra le sommaire ici
#
proc i:summaryhere {} {
	upvar #0 i:text w
	# pour empecher la marque de reculer:
	i:t "\n"
	$w mark set summary insert-1l
}

#
# On y va !!
#
proc i:hyper:go {t} {
	set tag [lmatch-regexp [$t tag names current] {tag_[0-9]*}]
	set r [$t tag nextrange $tag current+1l]
	$t yview [lindex $r 0]
}

#
#
#
proc i:hyper:hiliteoff {t x y} {
	$t tag remove hilite 1.0 end
}

proc i:hyper:motion {t} {
	$t tag remove hilite 1.0 end
	$t tag add hilite {current linestart} {current lineend}
}


set i:subs {
	{{\\`a} \xe0}
	{{\\\^a} \xe2}
	{{\\,c} \xe7}
	{{\\'e} \xe9}
	{{\\`e} \xe8}
	{{\\\^e} \xea}
	{{\\\^i} \xee}
	{{\\\^o} \xf4}
	{{\\\^u} \xfb}
	{{\\`u} \xf9}
	{{``} \xab}
	{{''} \xbb}
	}
proc i:doaccents {t} {
	global i:subs
	foreach d ${i:subs} {
		regsub -all -- [lindex $d 0] $t [lindex $d 1] t
		}
	return $t
}

proc i:accents {t} {
	return $t
}

#-- EOF info.tcl ----------------------------------------------------
