# -- mail.tcl
# smtp.tcl : mail par le protocol SMTP
# Auteur: Martin Andrews
#
# (DOMAINE PUBLIQUE)


# Global config for SMTP.

array set smtp {
    host achille
    port 25
}

# Get (and check for success) reply from SMTP server on $socket.

proc smtp_GetReply {socket} {
    while {1} {
	if {[gets $socket line] < 0} {
	    error "unexpected end of connection"
	}
	switch -glob -- $line {[23]?? *} {
	    return $line
	} {[23]??-*} {
	    # continue
	} default {
	    error $line
	}
    }
}

# Send SMTP command $cmd on $socket, and check reply.

proc smtp_Cmd {socket cmd} {
    puts $socket $cmd
    smtp_GetReply $socket
}

# smtp_send --
# Send email via SMTP gateway.

proc smtp_send {from dests body} {
    global smtp

    # Open connection to mail gateway.

    set mailsock [socket $smtp(host) $smtp(port)]
    fconfigure $mailsock -buffering line -translation crlf
    scan [fconfigure $mailsock -sockname] "%s %s %s" myhost null null2

    set code [catch {
	# Initial handshake

	smtp_GetReply $mailsock
	smtp_Cmd $mailsock "HELO $myhost"

	# Send the message - body includes subject etc..
	# Append a space to any lines with a solitary "." so that
	# they won't be confused with the terminator.  I don't
	# think this is the standard practice - what is?

	smtp_Cmd $mailsock "MAIL From: $from"
	foreach dest $dests {
	    smtp_Cmd $mailsock "RCPT To: $dest"
	}
	# On remplace un '.' tout seul par '..' : le maileur fait ce qu'il faut
	regsub "\n\\.\n" "DATA\n$body\n." "\n..\n" dataCmd
	smtp_Cmd $mailsock $dataCmd
    } msg]

    # Close connection.

    smtp_Cmd $mailsock "QUIT"
    close $mailsock

    return -code $code $msg
}

# -- EOF mail.tcl -----------------------------------------------------------------------
