# -- montableau.tcl
# exemple de dialogue appele depuis Prolog IV
# Pascal Bouvier, 29/11/96
# (c) PrologIA 1996
#

# ------------------------------------------------------------------------------
#
# ------------------------------------------------------------------------------
proc tcl_montableau {nLi nCol} {
	set W .montableau
	toplevel $W
	wm title $W "Valeurs a taper"
	
	for {set i 0} {$i < $nLi} {incr i} {
		set f [frame $W.l$i]
		pack $f
		for {set j 0} {$j < $nCol} {incr j} {
			set e [entry $f.e$j -relief sunken -bd 1 -width 10 -textvar v$i,$j]
			pack $e -side left
			}
		}
	button $W.b -text Ok -command [list set stop 1]
	pack $W.b
	update
	
	tkwait variable stop
	
	set res "\["
	for {set i 0} {$i < $nLi} {incr i} {
		set f $W.l$i
		if {$i != 0} {append res ",\n"}
		append res "\["
		for {set j 0} {$j < $nCol} {incr j} {
			set v [$f.e$j cget -textvar]
			global $v
			if {$j != 0} {append res ", "}
			append res "[set $v]"
			}
		append res "\]"
		}
	append res "\]"
		
#	puts "$res"
	destroy $W
	
	return "success($res). "
}

#
# Usage du cote Prolog IV :
# montableau(R, C, L) :- wsend2(['tcl_montableau ', R, ' ', C], success(L)).
# ?- montableau(2, 3, X).
#
# si on a mis des pseudo-termes dans le tableau ( comme pi ou cc(1.1,2.2) )
# top4(T,A) :- expand_term(f(T), (f(A):-Q), prolog4), call(Q).
# ?- montableau(3, 5, X), top4(X, Y).

# -- montableau.tcl
