# -- pc.tcl
# Bindings des touches (editeurs, menu, ...) pour PC
#
# Auteur:               Pascal Bouvier
# Creation:             25/09/96
# Modifications:
#
# (c) PrologIA 1996
# -----------------------------------------------------------------------------



@com {
On definit les classes d'evenements :
- ted_commun
- ted_motif
- ted_emacs
- ted_mac
- ted_pc

- tty_commun
- tty_motif
- tty_emacs
- tty_mac
- tty_pc

Les touches dans ce ficher :
C-h
C-x C-c C-v
C-t
C-d
C-n C-o C-s C-S C-w
C-a
C-f
C-r
C-k
x
INS C-INS S-INS
F2 F3 F4
BS DEL
RET
C-i TAB
}


#
# GENERAL
#

bind:addkey ted_pc <Key-KP_Enter> none {# nothing}

bind:addkey ted_pc <Key-Escape> none {# nothing}

bind:addkey ted_pc <Control-Key> none {# nothing}

bind:addkey ted_pc <Meta-Key> none {# nothing}

bind:addkey ted_pc <Alt-Key> none {# nothing }

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-v> paste {edc:paste %W}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-x> cut {edc:cut %W}

# TEXT PC CHCLIP
bind:addkey ted_pc <Control-Key-c> copy {edc:copy %W}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-t> twiddle-chars {
    if !$tk_strictMotif {
	tkTextTranspose %W
	eda:update %W
    }
}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-d> delete-next-char {
    if !$tk_strictMotif {
	%W delete insert
	eda:update %W
    }
}

# TEXT PC CHANGE
bind:addkey ted_pc <Key> insert-char {
    edc:insertkey %W %A
}

# TEXT PC CHANGE
bind:addkey ted_pc <Key-Insert> paste-selection {
    catch {edc:insertkey %W [selection get -displayof %W]}
}

# TEXT PC CHANGE
bind:addkey ted_pc <Key-F4> paste {edc:paste %W}

# TEXT PC CHANGE
bind:addkey ted_pc <Key-F2> cut {edc:cut %W}

# TEXT PC CHCLIP
bind:addkey ted_pc <Key-F3> copy {edc:copy %W}


# TEXT PC CHANGE
bind:addkey ted_pc <Shift-Insert> paste {edc:paste %W}

# TEXT PC CHCLIP
bind:addkey ted_pc <Control-Insert> copy {edc:copy %W}


# TEXT PC MOVE
bind:addkey ted_pc <Control-Key-a> select-all {
	edc:select-all %W
}

# TEXT PC CHANGE
bind:addkey ted_pc <Key-BackSpace> delete-previous-char {
    if {[%W tag nextrange sel 1.0 end] != ""} {
	%W delete sel.first sel.last
    } elseif [%W compare insert != 1.0] {
	%W delete insert-1c
    }
	eda:update %W
}

# TEXT PC CHANGE
bind:addkey ted_pc <Key-Delete> delete-next-char {
    if {[%W tag nextrange sel 1.0 end] != ""} {
	%W delete sel.first sel.last
    } else {
	%W delete insert
    }
	eda:update %W
}

# TEXT PC CHANGE
bind:addkey ted_pc <Key-Return> insert-return {
    edc:insertkey %W \n
}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-i> insert-tab {
    edc:insertkey %W \t
}


# TEXT PC CHANGE
bind:addkey ted_pc <Key-Tab> insert-tab {
    edc:insertkey %W \t
    focus %W
    break
}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-bracketleft> shift-left {
    edc:shift-left %W 
}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-Key-bracketright> shift-right {
    edc:shift-right %W 
}


# -----------------------------------------------------------------------------
# Buttons 
# -----------------------------------------------------------------------------

# MENU FILE:

# TEXT MOTIF MISC
bind:addkey ted_pc <Control-n> New {ed:New %W}

# TEXT MOTIF MISC
bind:addkey ted_pc <Control-s> Save {ed:Save %W}

# TEXT MOTIF MISC
bind:addkey ted_pc <Control-S> SaveAs {ed:SaveAs %W}

# TEXT MOTIF MISC
bind:addkey ted_pc <Control-w> Close {ed:Close %W ; break}


# MENU FIND:
# TEXT PC MISC
bind:addkey ted_pc <Control-f> dial-find  {ed:dial-find %W}

# TEXT PC MISC
bind:addkey ted_pc <Control-g> find-next  {ed:find-next %W}

# TEXT PC MISC
bind:addkey ted_pc <Control-G> find-selection  {ed:find-selection %W}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-r> replace {ed:replace %W}

# TEXT PC CHANGE
bind:addkey ted_pc <Control-R> replace-then-find {ed:replace-then-find %W}

# MENU SYNTAX:
# TEXT PC MISC
bind:addkey ted_pc <Control-k> check-syntax  {ed:check-syntax %W}


# -- EOF pc.tcl ----------------------------------------------------------
