# -- super.tcl
# Le superviseur Info-Project-Edit-Debug-etc... pour Prolog IV
#
# Auteur:		Pascal Bouvier
# Creation:		../01/95
# Modifications:	
#				PBO 07/05/95 Ajout de variables d'environnement
#				PBO 07/10/95 Le menu Info
#				PBO 01/12/96 tk4 et les fontes
#
# (c) PrologIA 1995-2000
# -----------------------------------------------------------------------------

global chemin TCLSRC
set forprolog4 1
global piadbg
set piadbg 0

if $forprolog4 {
	set super:bitmapdir $chemin/$TCLSRC
	set srcdir $chemin/$TCLSRC
	set BINP4 $chemin/bin
	set ETCP4 $chemin/etc
	} \
else {
	set aa /home/p3
	set super:bitmapdir $aa/TCL
	set srcdir $aa/TCL
	set BINP4 $aa/TCL
	set ETCP4 $aa/TCL
}

set super:mailp4 "p4bugs@prologianet.univ-mrs.fr"

global tcl_platform

# "emule" quelques fonctions de TclX
source $srcdir/x.tcl
source $srcdir/constcl.tcl
source $srcdir/dialog.tcl

#source $srcdir/pbentry.tcl
#source $srcdir/pbtext.tcl
source $srcdir/jauge.tcl
source $srcdir/utils.tcl
source $srcdir/font.tcl

if {$tcl_platform(platform) == "unix"} {
	source $srcdir/ufonts.tcl
} else {
	source $srcdir/pcfonts.tcl
	}
#source $srcdir/fonts.tcl

source $srcdir/choose.tcl
#source $srcdir/project.tcl
source $srcdir/binding.tcl
source $srcdir/edit.tcl
source $srcdir/find.tcl
source $srcdir/edprolog.tcl
source $srcdir/tty.tcl
#source $srcdir/console.tcl
source $srcdir/newcons.tcl
source $srcdir/window.tcl
source $srcdir/pref.tcl
source $srcdir/undef.tcl
source $srcdir/bugs.tcl
source $srcdir/info.tcl
source $srcdir/graf.tcl
source $srcdir/debug.tcl
source $srcdir/gd3.tcl
source $srcdir/perf.tcl
source $srcdir/config.tcl

# TMP: A refaire mieux !
if {$tcl_platform(platform) == "unix"} {
	set fontname_for_menus  {Helvetica 14 bold}
	#set fontname_for_menus {Helvetica 12 {}}
	} \
else {
	global fonts
	set f {"ms sans serif" 8 {}}
	set fonts($f) $f
	set fontname_for_menus $f
	}


set font_for_menus [font: $fontname_for_menus]
#3set font_for_menus $fonts($fontname_for_menus)

#
# La version de l'environnement
#
set super:version 2.3

#
# Les differents parametrages modifiables par l'utilisateur
# indexes par: lang
#
global super:pref
set super:pref(lang) "english"

global super:tmp
# un synonyme de super:tmp(lang) qui respecte la langue courante
uplevel #0 trace variable super:tmp(lang) w { super:set_lang }

#
# Appelee par Prolog IV
#
proc super:connection {} {
	return yes
}

# -----------------------------------------------------------------------------
# Appele une fois, c'est le startup general de l'environnement graphique.
# charge les preferences
# -----------------------------------------------------------------------------
proc super:init {} {
	#
	# Charge les preferences
	#
	pref:load
	super:load_language_strings

	#
	# On cree le super-menu Project Editor Quit
	#
	toplevel .super
	wm title .super [lang: T-toolbar]
	wm protocol .super WM_DELETE_WINDOW "super:exit"
	# TMP
#x11 ?	wm geo .super +10+30
	wm geo .super +80+0	; # pc

	#
	# Menubar 
	#
	frame .super.fm -relief raised -bd 1 -bg lightblue
	pack .super.fm -side top -fill x

	set mi [super:initinfo .super.fm]

#	set mp [project:init .super.fm]
	set me [edit:init .super.fm]
	set mw [window:init .super.fm]

	global font_for_menus
	set b [button .super.fm.quit -text [lang: TB.B-quit] \
			-bd 2 -highlightthickness 0 -padx 5 -pady 4 \
			-comm super:exit -font $font_for_menus]
#	pack $mi $mp $me $mw $b -side left -padx 2m -pady 2m
#OK	pack $mi $me $mw $b -side left -padx 2m -pady 2m
	pack $mi $me $mw $b -side left -padx 1m -pady 1m

#	tk_menuBar .super.fm $mi $mp $me $mw $b
#3	tk_menuBar .super.fm $mi     $me $mw $b

#3	focus default .super.fm
	focus .super.fm
	
	update
	wm minsize .super [winfo reqwidth .super.fm] [winfo reqheight .super.fm]
	wm maxsize .super [winfo reqwidth .super.fm] [winfo reqheight .super.fm]
}

# -----------------------------------------------------------------------------
# Appele lorsqu'on quitte (bouton Quit)
# -----------------------------------------------------------------------------
proc super:exit {} {
	if {[edit:exit] != 0} return
#	if {[project:exit] != 0} return
	#
	# On tue tous les processes qui trainent derriere
	#
	global process:list
	foreach pid ${process:list} {
		catch "process:kill $pid"
		}
	#
	# On tue tous les fichiers temporaires de /tmp locaux a l'env.
	#
	foreach name [glob -nocomplain [fs:tmpfile *-[pid]*]] {
#3		catch "exec /bin/rm $name"
		fs:delete-f $name
		}

	exit 0
}

#
# charge les chaines du langage courant (pref)
#
proc super:load_language_strings {} {
	global srcdir
	upvar #0 super:pref(lang) lang
	eval [i:faccents $srcdir/$lang.str]
}

#
# Les langues
# Construit la liste des langues disponibles (dans la langue courante)
#
proc super:makeuserlangmenu {root} {
	global srcdir super:tmp(lang)
	set L [glob $srcdir/*.str]
	set L [string tolower $L]
	set m [menu $root.mlang]
	foreach l $L {
		set lf [file root [file tail $l]]
		set l [lang: $lf]
		$m add command -label $l \
				-command "set super:tmp(lang) \"$lf\""
		}
	return $m
}

#
proc super:set_lang {n1 n2 op} {
	global super:tmp_lang super:tmp
	set super:tmp_lang [lang: [set super:tmp(lang)]]
	}



@com {
Info:
	===========
	A propos de Prolog IV ...		# versions, etc...
	-----------
	Preferences ...					# diverseries
	Save Preferences				# le sauve dans un fichier
	-----------
	? Credits						# TCL/TK, etc...
	-----------
	Bug Report ...					# appel le mail
	-----------
	Read Me ...						# Une page pour des infos
	Help							# on le met ici ?
	===========
}

# -----------------------------------------------------------------------------
# Cree le menu Info
# -----------------------------------------------------------------------------
proc super:initinfo {rootfm} {
	upvar #0 font_for_menus f
	set mb $rootfm.mbinfo
	set m $mb.minfo
	menubutton $mb -menu $m -text [lang: TB.M-info] \
			-padx 5 -pady 5 -relief raise -bd 2 -font $f

	menu $m
	$m add command -font $f -label [lang: show-aboutp4] \
			-command super:AboutP4
	$m add sepa
	$m add command -font $f -label [lang: show-prefs] \
			-command pref:init
	$m add command -font $f -label [lang: save-prefs] \
			-command pref:save
	$m add sepa
	$m add command -font $f -label [lang: show-credits] \
			-command super:Dial_Credits -state disabled

global tcl_platform
if {$tcl_platform(platform) == "unix"} {
	$m add sepa
	$m add command -font $f -label [lang: new-bug-report] \
			-command bug:Dial_Bug
	}

#	$m add sepa
#	$m add command -font [font: "Helvetica 24 bold"] \
#			-label [lang: show-readme] \
#			-command i:init

	return $mb
}

# -----------------------------------------------------------------------------
# La version de l'envionnement, de Prolog IV, le copyright
# MENU
# -----------------------------------------------------------------------------
proc super:AboutP4 {} {
	upvar #0 font_for_menus fnt
	global super:bitmapdir

	set w .aboutp4
	toplevel $w -bg white ; wm withdraw $w
	wm title $w [lang: T-aboutp4]
#3	wm geo $w +400+300

	frame $w.f -bg white
#	label $w.f.lico -bitmap @${super:bitmapdir}/p4.xbm -bg lightblue -fg red
	
	if {[info command iconep4] == ""} {
		image create photo iconep4 -file ${super:bitmapdir}/prolog4N.gif }
	label $w.f.lico -image iconep4 -borderwidth 0
	message $w.f.mess -bg white -text "Prolog IV\xAE Development System\n\
			v1.3, [lang: february] 2000\n\
			\n\
			Copyright \xA9 PrologIA 1995-2000\n\
			Marseille\n\
			\n\
			[lang: phone:] (+33) (0)4 91 26 86 36\n\
			[lang: fax:] (+33) (0)4 91 41 96 37\n\
			[lang: e-mail:]  p4bugs@prologianet.univ-mrs.fr" \
			-aspect 400 -font $fnt -just center
	pack $w.f.lico $w.f.mess -side left -padx 2m

	button $w.bok -text Ok -command "destroy $w" -highlightthickness 1 \
		-highlightbackground gray95
	pack $w.f $w.bok -side top -padx 5m -pady 5m -ipadx 5m -ipady 2m
	update
	dial:centrer $w
	wm deiconify $w
	grab $w
	tkwait window $w
}


#-- EOF super.tcl -------------------------------------------------------------
