#
# Utilitaires
#

proc @com {commentaire} {}

proc unhiliteallfound {} {unhiliteall}

proc unhiliteall {} {
	global edit_eds
	foreach ed [array names edit_eds] {
		ed:unhilite-all-found $ed.t
		}
}


proc errputs {s} {
	global piadbg
	if $piadbg {puts stderr $s}
	}


proc bip {} {
#3	puts -nonewline "\07"; flush stdout
	bell
}

proc quit {{s 0}} {
	exit $s
}

#
# Si c'est un chemin complet
#
proc is-fullpath {path} {
	if {[file pathtype $path] == "absolute"} {
		return 1
		}
	return 0
#3	if {"[string index $path 0]" == "/"} {
#3		return 1
#3		}
#3	return 0
	}

#
# Si c'est un fichier existant et ordinaire et lisible
#
proc is-existing&readable&regular {path} {
    if {[file exists $path] && [file isfile $path] && [file readable $path] } {
		return 1
		}
	return 0
}

#
# pour remplacer:
#exec echo ":-unit('$tmpfic.p4').\n:-debug." > $tmpfic.p4
#
proc fs:strtofile {str filename} {
	set f [open $filename w]
	puts -nonewline $f $str
	close $f
}

#
# pour remplacer:
# exec cat >> $tmpfic.p4 << [$ed.t get $deb $fin]
#
proc fs:strtofile-append {str filename} {
	set f [open $filename a]
	puts -nonewline $f $str
	close $f
}

#
proc fs:tmpfile {name} {
	return [file join [fs:tmp] $name]
}

#
proc fs:delete {args} {
	foreach name $args {
		file delete $name
		}
}

#
proc fs:delete-f {args} {
	foreach name $args {
		catch {file delete $name}
		}
}

#
proc fs:tmp {} {
	global env tcl_platform
	if [catch {set t $env(TMP)}] {
		if [catch {set t $env(TMPDIR)}] {
			if [catch {set t $env(TEMP)}] {
				if [catch {set t $env(TEMPDIR)}] {
					if {$tcl_platform(platform) == "unix"} {
						set t /tmp
						} \
					else {
						set t .
						}
					}
				}
			}
		}
	return $t
	}

proc neuf {{W .}} {
	foreach i [pack slaves $W] {destroy $i}
}

proc packinfo W {
	foreach i [pack slaves $W] {
		puts "pack $i  [pack newinfo $i]"
		}
}

proc tconfig {w {t -notag-}} {
	if {$t == "-notag-"} {
		set Lt [$w tag names]
		} \
	else {
		set Lt [list $t]
		}
	foreach t $Lt {
		puts "-------- Tag '$t' of win '$w' --------"
		foreach i [$w tag config $t] {
			if {[llength $i]==5} {
				puts [format "%20s = %s" [lindex $i 0] [lindex $i 4]]
				}
			}
		}
}

proc config w {
	foreach i [$w config] {
		if {[llength $i]==5} {
			puts [format "%20s = %s" [lindex $i 0] [lindex $i 4]]
			}
		}
}

#
# On oublie
#
proc oublie {{W .g}} {
	foreach name [pack slaves $W] {pack forget $name}
}


#
# faire pour toute la hierarchie 
#

proc forslaves {W cmd} {
	foreach name [pack slaves $W] {	
		$cmd $name
		forslaves $name $cmd
		}
}

proc forchild {W cmd} {
	foreach name [winfo child $W] {	
		$cmd $name
		forchild $name $cmd
		}
}

#
# Copie les elements du tableau src dans le tableau dest
# LES DEUX TABLEAUX DOIVENT ETRE GLOBAUX !
# 
proc arraycopy {dest src} {
	upvar #0 $dest d $src s
	foreach idx [array names s] {
		set d($idx) $s($idx)
		}
}

proc afterall {} {
	foreach name [after info] {
		puts "$name: [after info $name]"
		}
}

proc showproc {P} {
	set L {}
	if {[info proc $P] != ""} {
		set La {}
		foreach arg [info args $P] {
			if [info default $P $arg def] {
				set arg [list $arg $def]
				}
			lappend La $arg
			}
		lappend L proc $P $La [info body $P]
		}
	return $L
}


proc reputs {} {

	if {[info command trueputs] != ""} {
		wm deiconify .stdouterr
		} \
	else {
		rename puts trueputs
		rename falseputs puts
		winit
		}
}

proc restoreputs {} {
	if {[info command trueputs] == ""} return
	rename puts falseputs
	rename trueputs puts
}

proc winit {} {
	set W [toplevel .stdouterr]
	wm withdraw $W
	wm title $W "stdout/stderr"
	set t [text $W.t]
	pack $t
	$t tag config stderr -foreg red
	$t tag config stdout -foreg blue
}

proc wputs {s} {
	.stdouterr.t insert end $s stdout
}

proc weputs {s} {
	.stdouterr.t insert end $s stderr
}

proc falseputs {args} {
	set nonew 0
	set a1 [lindex $args 0]
	if {[string compare $a1 "-nonewline"] == 0} {
		set nonew 1
		set args [lrange $args 1 end]
		}
	set a1 [lindex $args 0]
	if {[llength $args] == 1} {
		if $nonew {wputs $a1} else {wputs $a1\n}
		} \
	elseif {$a1 == "stdout"} {
		set a2 [lindex $args 1]
		if $nonew {wputs $a2} else {wputs $a2\n}
		} \
	elseif {$a1 == "stderr"} {
		set a2 [lindex $args 1]
		if $nonew {weputs $a2} else {weputs $a2\n}
		} \
	else {
		if $nonew {eval trueputs -nonewline $args} else {eval trueputs $args}
		}
}

# -----------------------------------------------------------------------------
# -- copier_itemcanvas wsrc it wdest
# Copie un item d'un canvas vers un autre.
# -----------------------------------------------------------------------------
proc copier_itemcanvas {wsrc it wdest} {
	set type [$wsrc type $it]
	set coord [$wsrc coord $it]
	set newit [eval $wdest create $type $coord]
	foreach opt [$wsrc itemconf $it] {
		set optname [lindex $opt 0]
		set valeur  [lindex $opt 4]
		if {[string compare $optname "-smooth"] == 0} {
			# Un bug dans l'extension "hash" qui rend "bezier"
			# au lieu de 1 pour -smooth (et non-reentrant)
			if {[string compare $valeur "0"]  &&
				[string compare $valeur "1"]} {
				set valeur 1
				}
			}
		$wdest itemconf $newit $optname $valeur
		}
	return $newit
}



# -----------------------------------------------------------------------------
# -- copier_canvas wsrc wdest
# Copie les items d'un canvas vers un autre.
# -----------------------------------------------------------------------------
proc copier_canvas {wsrc wdest} {
	foreach it [$wsrc find withtag all] {
		set type [$wsrc type $it]
		set coord [$wsrc coord $it]
		set newit [eval $wdest create $type $coord]
		foreach opt [$wsrc itemconf $it] {
			set optname [lindex $opt 0]
			set valeur  [lindex $opt 4]
			if {[string compare $optname "-smooth"] == 0} {
				# Un bug dans l'extension "hash" qui rend bezier
				# au lieu de 1 pour -smooth (et non-reentrant)
				if {[string compare $valeur "0"]  &&
					[string compare $valeur "1"]} {
					set valeur 1
					}
				}
			$wdest itemconf $newit $optname $valeur
			}
		}
}


#
# une commande
#
proc setgray {W} {
	$W config -bg gray
}

