# -- window.tcl
# Pour la liste des fenetres dans un menu principal
#
# Auteur:		Pascal Bouvier
# Creation:		05/10/95
# Modifications:	
#
# (c) PrologIA 1995
# -----------------------------------------------------------------------------


# ==== G L O B A L E S =======================================


# ==== P R O C S =======================================

proc window:init {rootfm} {
	set mw [window:create_menu $rootfm]
#	pack $mw -side left -padx 2m -pady 2m

	#
	# Enregistrement de la callback lors de la creation/destruction d'editeur
	#
	edit:recordcallback window:notify

	return $mw
}

#
#
#
proc window:create_menu {rootfm} {
	upvar #0 font_for_menus f
	set mb $rootfm.mbwin
	set m $mb.mwin
	menubutton $mb -menu $m -text [lang: TB.M-windows] \
			-padx 5 -pady 5 -relief raise -bd 2 -font $f

	menu $m
#	$m add command -font $f -label "?..." -command nyi
	$m add sepa

	global window:menu
	set window:menu $m
	return $mb
}

# -----------------------------------------------------------------------------
# Les notifieurs appeles depuis l'editeur
# Il faut les avoir enregistres
# -----------------------------------------------------------------------------
proc window:notify_record {ed file} {
	upvar #0 window:menu m
	upvar #0 font_for_menus f

	set ti [wm title [winfo toplevel $ed]]
	$m add command -label $ti -command "window:raise $ed" -font $f
}

#
proc window:notify_unrecord {ed} {
	upvar #0 window:menu m
	global edit_eds

	set ti [edit:longtitle $edit_eds($ed)]
	$m delete $ti
}

#
# L'editeur donne passe au premier plan
#
proc window:raise {ed} {
	set top [winfo toplevel $ed]
	raise $top
	wm deiconify $top
	focus $ed.t
}

#-- EOF window.tcl -------------------------------------------------------------
