#
# Des choses de TclX
#

global tcl_platform
global val_sigusr1

# On most unix:
set val_sigusr1 30


if {$tcl_platform(platform) == "unix"} {
	global auto_path
	lappend auto_path $BINP4 ; package require pbsignal
	if {$tcl_platform(os) == "SunOS"} {
		if {[string index $tcl_platform(osVersion) 0] == 5} {
			set val_sigusr1 16
			}
		}
	if {$tcl_platform(os) == "Linux"} {
		set val_sigusr1 10
		}
	}
if {$tcl_platform(platform) == "windows"} {
	global auto_path
	lappend auto_path $BINP4 ; package require example
	}

proc getclock {} {clock seconds}

proc fcntl {file _ blocking} {
	errputs "***fcntl: appel obsolete pour compatibilite ***"
	fconfigure $file -blocking [expr 1 - $blocking]
	}

proc union {L1 L2} {
	return [concat $L1 $L2]
	}

proc kill {SIG pid} {
	global val_sigusr1
	switch $SIG {
		SIGTERM {set sig 15}
		SIGINT  {set sig 2}
		SIGUSR1 {set sig $val_sigusr1}
		default error
		}
#	exec /bin/kill -$sig $pid
	mykill $sig $pid
	}

proc lmatch-glob {L pat} {
	set R {}
	while 1 {
		set pos [lsearch -glob $L $pat]
		if {$pos == -1} break
		lappend R [lindex $L $pos]
		incr pos
		set L [lrange $L $pos end]
		}
	return $R
}

proc lmatch-regexp {L pat} {
	set R {}
	while 1 {
		set pos [lsearch -regexp $L $pat]
		if {$pos == -1} break
		lappend R [lindex $L $pos]
		incr pos
		set L [lrange $L $pos end]
		}
	return $R
}

proc lempty {L} {
	if {[llength $L] == 0} {return 1}
	return 0
}

# pour l'arite deux seulement
proc lassign {L a b} {
	upvar #1 $a va
	upvar #1 $b vb
	set va [lindex $L 0]
	set vb [lindex $L 1]
}

proc translit {sou dest str} {
	regsub -all $sou $str $dest L
	return $L
}

proc for_file {var filename script} {
	upvar $var line
	set f [open $filename r]
	while {[gets $f line] >= 0} {
		uplevel $script
		}
	close $f
}

