% -- datetime.p4 --
% Quelques fonctions sur les dates et temps, demand'e a TCL.
% Some date and time functions, asked to TCL.
%
% Pascal Bouvier, le Wed Oct 21 17:44:43  1998
% (c) PrologIA 1998

% Donne une date sous forme d'atome  (Ex: 'Wed Oct 21 17:44:43  1998')
datestr(X) :-
	wsend2(["set _ '[clock format [clock seconds]]'.\\ "], X).

% Retourne Mois (1..12), Jour (1..31), Annee (entier a 4 chiffres)
date(M, J, A) :-
	wsend2(['set _ "d([clock format [clock seconds] -format {%m,%d,%Y}]). "'], d(M,J,A)).
	

% Retourne un atome contenant l'heure : Heures:Minutes:Secondes  (Ex: 17:44:43)
timestr(X) :-
	wsend2(["set _ '[clock format [clock seconds] -format {%H:%M:%S}]'.\\ "], X).

% Retourne l'heure sous la forme des 3 entiers :  Heure (0..23) Minutes (0..59) Secondes (0..59) .
time(H, M, S) :-
	wsend2(['set _ "d([clock format [clock seconds] -format {%H,%M,%S}]). "'], d(H,M,S)).
	

% -- EOF datetime.p4 --