% -- rectangle.p4 --
% Remplir un rectangle 1 x A avec N carres differents et inconnus
% Filling a rectangle 1 x A with N different unknown squares .
% Example  from Prolog III, Alain Colmerauer
%
% Pour remplir un rectangle avec 9 carres differents et inconnus :
% To fill a rectangle with 9 different unknown squares: 
% >> size(C) = 9, remplirRectangle(A,C).
% (rend huit solutions : deux familles de quatre symetries)
% (gives eight solutions: two families of four symmetries)

remplirRectangle(A, C) :-
	gelin(A,1),
	creerCarres(C),
	remplirZone([-1,A,1], _L, C, []).
%   {A >= 1}.

creerCarres([]).
creerCarres([B|C]) :-
	gtlin(B,0),
	creerCarres(C),
	rendreDistinct(B, C).
%   {B > 0}.

rendreDistinct(_B, []).
rendreDistinct(B, [B1|C]) :-
	dif(B, B1),
	rendreDistinct(B, C).
%   {B # B1}.

remplirZone([V|L], [V|L], C, C) :-
	gelin(V,0).
%   {V >= 0}.
remplirZone([V|L], L3, [B|C], C2 ) :-
	ltlin(V,0),
	placerCarre(B, L, L1),
	remplirZone(L1, L2, C, C1),
	remplirZone([V + B, B | L2], L3, C1, C2).
%   {V < 0}.

placerCarre(B, [H, 0, H1 | L], L1) :-
	gtlin(B,H),
	placerCarre(B, [H + H1 | L], L1).
%   {B > H}.
placerCarre(B, [H, V | L], [-B + V | L]) :-
	B = H.
%   {B = H}.
placerCarre(B, [H | L], [-B , H - B | L]) :-
	ltlin(B,H).
%   {B < H}.


% -- EOF rectangle.p4 ---------------------------------------------%