% -- send.p4 --
% Determiner les chiffres distincts S E N D M O R Y, (avec S & M # 0)
% tels que L'addition tombe juste :
% Determine distinct digits S E N D M O R Y, with S and M not equal to zero,
% such that the following is correct:
%    SEND
%  + MORE
%  ======
%   MONEY
%
%
% (c) PrologIA 1989-2000

solution(I, J, K) :-
   dif(S,0),
   dif(M,0),
   I + J = K,
   I =            1000*S + 100*E + 10*N + D ,
   J =            1000*M + 100*O + 10*R + E ,
   K = 10000*M  + 1000*O + 100*N + 10*E + Y ,
   allDifferentDigits([M,S,O,E,N,R,D,Y]),
   integers([M,S,O,E,N,R,D,Y]).

integers([]) .
integers([E|R]) :- enumlin(E), integers(R).

allDifferentDigits([]) .
allDifferentDigits([X|S]) :-
	lelin(0,X), lelin(X,9),
	outsideOf(X, S),
	allDifferentDigits(S).

outsideOf(X, []) .
outsideOf(X, [Y|S]) :- dif(X,Y), outsideOf(X, S).

% Query:
%
% solution(I,J,K).

% -- EOF send.p4 --