% -- stone.p4 --
% Un puzzle pris dans la Lettre de la Programmation Logique (Nov. 1996)
% A puzzle from Letter of Logic Programming  (Nov 1996)
%
% Pascal Bouvier, le 20/12/96
% (c) PrologIA 1996, 1997
%
% Une pierre de 40 kg se brise en 4 morceaux;
% avec ces morceaux, on peut peser tous les objets de 1 a 40 kg.
% Quel est le poids de ces morceaux ?
%
% A 40 kg stone is broken into four pieces;
% with these pieces, every objets from 1 to 40 kg can be weighted
% on a balance. What is the weight of each pieces ?
%
% >> go(L).
% L = [1,3,9,27].
% en 1.8 sec., avec un temps total de 18 s. (Sparc Classic)
% in 1.8 sec., with a total time of 18 s. (Sparc Classic)
%

go(L) :-
	L = [P1, P2, P3, P4],
	P1.+.P2.+.P3.+.P4 = 40,
	P1 ~ cc(1,40),
	P2 ~ cc(1,40),
	P3 ~ cc(1,40),
	P4 ~ cc(1,40),
	P1 le P2,
	P2 le P3,
	P3 le P4,
	tous(1,40, L),
	intsplit(L).

%
% Tous les poids entiers entre A et B doivent etre pesables.
% Every integral weight between A and B should be "weightable".
%
tous(A, A, _) :- !.
tous(A, B, L) :- 
	peser(A, L),
	tous(A.+.1, B, L).

%
% Chaque poids peut etre d'un cote ou de l'autre de la balance (ou inutilise)
% A weight can be put on any side of the balance (or not used).
%
peser(A, [P1, P2, P3, P4]) :-
	A = B1.*.P1 .+. B2.*.P2 .+. B3.*.P3 .+. B4.*.P4,
	B1 ~ -1 u 0 u 1,
	B2 ~ -1 u 0 u 1,
	B3 ~ -1 u 0 u 1,
	B4 ~ -1 u 0 u 1.
	
% -- EOF stone.p4 ------------------------------------------------------------%

